/*
 * Copyright (c) 2006, 2009 Borland Software Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare - Xpand language syntax
 *     Artem Tikhomirov (Borland) - LALR grammar
 *                                - Migration to OCL expressions
 */
package org.eclipse.gmf.internal.xpand.parser;

public class XpandLexerprs implements lpg.lpgjavaruntime.ParseTable, XpandLexersym {

    public interface IsKeyword {
        public final static byte isKeyword[] = {0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0
        };
    };
    public final static byte isKeyword[] = IsKeyword.isKeyword;
    public final boolean isKeyword(int index) { return isKeyword[index] != 0; }

    public interface BaseCheck {
        public final static byte baseCheck[] = {0,
            1,1,3,3,3,1,1,1,1,1,
            5,1,1,1,1,1,1,1,1,1,
            1,2,2,2,1,1,1,1,2,1,
            1,1,2,1,1,2,4,1,2,1,
            1,1,2,2,3,2,2,0,1,2,
            2,2,1,2,1,2,3,2,3,3,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,2,3,1,1,1,1,
            1,2,1,2,2,2,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,2,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,2,1,2,
            1,2,0,1,3,3,3,3,3,3,
            4,4,3,3,2,2,1,1,2,2,
            2,3,1,3,1,1,1,1,1,1,
            1,3,0,1,1,3,0,2,1,1,
            1,1,1,0,1,12,0,2,3,4,
            5,6,7,8,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,2
        };
    };
    public final static byte baseCheck[] = BaseCheck.baseCheck;
    public final int baseCheck(int index) { return baseCheck[index]; }
    public final static byte rhs[] = baseCheck;
    public final int rhs(int index) { return rhs[index]; };

    public interface BaseAction {
        public final static char baseAction[] = {
            23,23,23,23,23,23,23,23,23,23,
            23,23,23,23,23,23,23,23,23,23,
            23,23,23,23,23,23,23,23,23,23,
            23,23,23,23,23,23,23,23,23,23,
            23,25,26,26,26,30,30,30,30,31,
            31,29,29,11,11,51,51,33,18,18,
            18,5,5,5,5,5,4,4,4,4,
            2,2,2,2,2,2,2,2,2,2,
            2,2,2,2,2,2,2,2,2,2,
            2,2,2,2,2,2,3,3,3,3,
            3,3,3,3,3,3,3,3,3,3,
            3,3,3,3,3,3,3,3,3,3,
            3,3,1,1,1,1,1,1,1,1,
            1,1,53,53,53,53,53,53,53,53,
            54,54,54,54,54,54,54,54,54,54,
            54,54,52,52,55,55,55,19,19,56,
            56,32,32,16,16,16,16,35,35,35,
            35,35,35,35,35,35,35,35,35,35,
            35,35,35,35,35,35,35,35,35,35,
            35,35,35,35,35,35,35,6,6,6,
            6,6,6,6,6,6,6,6,6,6,
            6,6,6,6,6,6,6,6,6,6,
            6,6,6,6,6,6,7,7,7,7,
            7,7,7,7,7,7,7,7,7,7,
            7,7,7,7,7,7,7,7,7,7,
            7,7,7,7,20,20,12,12,36,36,
            36,36,8,15,15,15,15,34,34,34,
            34,34,34,34,34,37,37,37,37,21,
            21,21,21,13,13,13,13,13,24,38,
            38,14,14,17,17,27,27,27,27,27,
            27,27,27,27,28,23,23,23,23,23,
            23,23,23,23,23,13,13,13,21,21,
            21,21,23,39,39,23,23,40,40,42,
            42,42,42,42,41,41,23,43,43,43,
            43,43,43,43,43,45,45,9,9,9,
            9,9,9,9,9,9,9,22,22,22,
            22,22,22,46,46,46,46,46,46,47,
            47,47,47,47,47,48,48,48,48,48,
            48,49,49,49,49,49,49,10,10,10,
            10,10,10,10,10,10,10,10,10,10,
            10,10,10,10,10,10,10,10,44,44,
            1862,53,66,67,163,161,1660,284,66,67,
            283,431,2809,256,287,2061,565,2716,285,291,
            526,2704,54,425,2,6,7,8,9,656,
            43,459,518,422,1968,280,66,67,279,44,
            459,254,321,2471,2069,284,66,67,283,2732,
            53,256,287,2550,281,289,285,291,509,2623,
            524,611,2069,284,66,67,283,2743,53,256,
            287,2802,499,595,285,291,509,2800,562,612,
            1,264,66,67,263,266,265,2743,53,2170,
            280,66,67,279,2804,330,254,321,582,2271,
            284,66,67,283,102,2718,256,287,2727,281,
            290,285,292,162,2754,54,1761,284,66,67,
            283,326,328,256,287,2765,54,2551,285,292,
            1355,264,66,67,263,266,265,106,348,355,
            346,2806,350,349,490,47,345,2372,276,66,
            67,275,2776,54,277,2552,165,66,67,164,
            415,572,1456,264,66,67,263,266,265,211,
            348,355,2787,54,350,349,2813,45,357,358,
            519,627,338,262,258,2370,2808,315,348,355,
            540,339,350,349,2699,2805,363,364,419,348,
            355,206,1860,350,349,2811,2829,369,370,523,
            348,355,2831,2832,350,349,1658,2619,375,376,
            627,348,355,547,2702,350,349,2448,2815,357,
            358,2830,2833,340,1147,348,355,696,696,350,
            349,696,343,381,382,341,1557,268,66,67,
            267,2473,53,66,67,163,696,342,696,696,
            696,696,535,696,696,696,696,678,2631,165,
            66,67,164,696,696,696,696,696,696,696,
            52,271,696,344,696,696
        };
    };
    public final static char baseAction[] = BaseAction.baseAction;
    public final int baseAction(int index) { return baseAction[index]; }
    public final static char lhs[] = baseAction;
    public final int lhs(int index) { return lhs[index]; };

    public interface TermCheck {
        public final static byte termCheck[] = {0,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            100,0,102,103,104,0,1,2,3,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,27,28,29,30,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,57,58,59,60,61,62,63,64,
            65,66,67,68,69,70,71,72,73,74,
            75,76,77,78,79,80,81,82,83,84,
            85,86,87,88,89,90,91,92,93,94,
            95,96,97,98,99,0,101,102,103,104,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            105,101,102,103,0,1,2,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,71,72,73,74,75,
            76,77,78,79,80,81,82,83,84,85,
            86,87,88,89,90,91,92,93,94,95,
            96,97,98,99,0,101,102,103,0,1,
            2,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,21,
            22,23,24,25,26,27,28,29,30,31,
            32,33,34,35,36,37,38,39,40,41,
            42,43,44,45,46,47,48,49,50,51,
            52,53,54,55,56,57,58,59,60,61,
            62,63,64,65,66,67,68,69,70,71,
            72,73,74,75,76,77,78,79,80,81,
            82,83,84,85,86,87,88,89,90,91,
            92,93,94,95,96,97,98,99,0,101,
            102,103,0,1,2,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            28,29,30,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,92,93,94,95,96,97,
            98,99,0,101,102,103,0,1,2,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,92,93,
            94,95,96,97,98,99,0,101,102,103,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            0,101,102,103,0,1,2,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,71,72,73,74,75,
            76,77,78,79,80,81,82,83,84,85,
            86,87,88,89,90,91,92,93,94,95,
            96,97,98,99,0,101,102,103,0,1,
            2,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,21,
            22,23,24,25,26,27,28,29,30,31,
            32,33,34,35,36,37,38,39,40,41,
            42,43,44,45,46,47,48,49,50,51,
            52,53,54,55,56,57,58,59,60,61,
            62,63,64,65,66,67,68,69,70,71,
            72,73,74,75,76,77,78,79,80,81,
            82,83,84,85,86,87,88,89,90,91,
            92,93,94,95,96,97,98,99,0,101,
            102,103,0,1,2,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            28,29,30,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,92,93,94,95,96,97,
            98,99,0,101,102,103,0,1,2,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,0,18,19,20,21,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,92,93,
            94,95,96,97,98,99,0,101,102,103,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,0,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,99,
            0,101,102,103,0,1,2,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,71,72,73,74,75,
            76,77,78,79,80,81,82,83,84,85,
            86,87,88,89,90,91,92,93,94,95,
            96,97,98,99,100,0,1,2,3,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,27,28,29,30,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,57,58,59,60,61,62,63,64,
            65,66,67,68,69,70,71,72,73,74,
            75,76,77,78,79,80,81,82,83,84,
            85,86,87,88,89,90,91,92,93,94,
            95,96,97,98,99,100,0,1,2,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,0,0,93,
            94,95,96,97,98,99,100,0,102,0,
            1,2,3,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            21,22,23,24,25,26,27,28,29,30,
            31,32,33,34,35,36,37,38,39,40,
            41,42,43,44,45,46,47,48,49,50,
            51,52,53,54,55,56,57,58,59,60,
            61,62,63,64,65,66,67,68,69,70,
            71,72,73,74,75,76,77,78,79,80,
            81,82,83,84,85,86,87,88,89,90,
            91,92,93,94,95,96,97,98,101,100,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,98,0,
            100,0,1,2,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,27,28,
            29,30,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,71,0,73,74,75,76,77,78,
            79,80,81,82,83,84,85,86,87,88,
            89,90,91,92,93,0,0,0,0,98,
            99,100,101,0,105,104,105,0,1,2,
            3,4,5,6,7,8,9,10,11,12,
            13,14,15,16,17,18,19,20,21,22,
            23,24,25,26,27,28,29,30,31,32,
            33,34,35,36,37,38,39,40,41,42,
            43,44,45,46,47,48,49,50,51,52,
            53,54,55,56,57,58,59,60,61,62,
            63,64,65,66,67,68,69,70,71,72,
            73,74,75,76,77,78,79,80,81,82,
            83,84,85,86,87,88,89,90,91,92,
            0,94,95,96,97,98,0,100,0,1,
            2,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,21,
            22,23,24,25,26,27,28,29,30,31,
            32,33,34,35,36,37,38,39,40,41,
            42,43,44,45,46,47,48,49,50,51,
            52,53,54,55,56,57,58,59,60,61,
            62,63,64,65,66,67,68,69,70,71,
            72,73,74,75,76,77,78,79,80,81,
            82,83,84,85,86,87,88,89,90,91,
            92,93,94,95,96,97,106,101,100,0,
            1,2,3,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            21,22,23,24,25,26,27,28,29,30,
            31,32,33,34,35,36,37,38,39,40,
            41,42,43,44,45,46,47,48,49,50,
            51,52,53,54,55,56,57,58,59,60,
            61,62,63,64,65,66,67,68,69,70,
            71,72,73,74,75,76,77,78,79,80,
            81,82,83,84,85,86,87,88,89,90,
            91,92,0,94,95,96,97,98,0,100,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,92,93,94,95,96,97,0,0,
            100,0,1,2,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,27,28,
            29,30,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,71,72,73,74,75,0,77,78,
            79,80,81,82,83,84,85,86,87,88,
            89,90,93,16,93,94,95,96,97,98,
            0,100,0,1,2,3,4,5,6,7,
            8,9,10,11,0,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            28,29,30,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,73,0,0,0,75,0,0,
            0,0,1,2,3,4,5,6,7,8,
            9,10,11,14,13,14,15,16,17,18,
            19,0,100,22,23,24,25,26,27,28,
            29,30,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,0,0,
            70,0,0,72,0,0,0,0,0,11,
            0,1,2,3,4,5,6,7,8,9,
            10,11,20,13,14,15,16,17,18,19,
            0,100,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,0,0,0,
            0,0,72,0,1,2,3,4,5,6,
            7,8,9,10,11,0,13,0,20,18,
            0,0,104,20,0,0,0,12,0,12,
            100,0,1,2,3,4,5,6,7,8,
            9,10,0,1,2,3,4,5,6,7,
            8,9,10,0,1,2,3,4,5,6,
            7,8,9,10,0,1,2,3,4,5,
            6,7,8,9,10,0,1,2,3,4,
            5,6,7,8,9,10,0,1,2,3,
            4,5,6,7,8,9,10,71,67,0,
            69,0,76,0,0,0,0,0,0,0,
            0,12,0,12,0,12,12,91,92,11,
            21,13,15,11,21,99,21,17,0,0,
            0,0,0,19,0,0,0,0,0,0,
            11,13,12,12,0,0,0,0,0,17,
            0,17,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,68,0,0,
            0,0,67,0,0,74,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0
        };
    };
    public final static byte termCheck[] = TermCheck.termCheck;
    public final int termCheck(int index) { return termCheck[index]; }

    public interface TermAction {
        public final static char termAction[] = {0,
            334,818,819,820,821,822,823,824,825,826,
            827,796,919,770,781,783,795,804,805,809,
            916,918,766,767,768,769,771,772,773,774,
            775,776,777,778,779,780,782,784,785,786,
            787,788,789,790,791,764,792,793,794,797,
            798,799,800,801,802,803,806,807,808,810,
            811,812,813,814,815,816,817,894,917,893,
            1027,757,921,904,905,1028,760,909,898,899,
            900,901,906,910,911,912,913,914,915,895,
            896,758,759,897,902,920,903,908,907,761,
            765,327,1029,1025,1031,696,818,819,820,821,
            822,823,824,825,826,827,796,919,770,781,
            783,795,804,805,809,916,918,766,767,768,
            769,771,772,773,774,775,776,777,778,779,
            780,782,784,785,786,787,788,789,790,791,
            1052,792,793,794,797,798,799,800,801,802,
            803,806,807,808,810,811,812,813,814,815,
            816,817,894,917,893,1048,757,921,904,905,
            1049,760,909,898,899,900,901,906,910,911,
            912,913,914,915,895,896,758,759,897,902,
            920,903,908,907,761,696,1047,1050,1043,579,
            408,818,819,820,821,822,823,824,825,826,
            827,2148,919,770,781,783,1056,1058,1055,1057,
            916,918,766,767,768,769,771,772,773,774,
            775,776,777,778,779,780,782,784,785,786,
            787,788,789,790,791,1052,1083,1084,1085,1086,
            1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,
            1097,1098,1099,1100,1101,1102,1103,894,917,893,
            1048,757,921,904,905,1049,760,909,898,899,
            900,901,906,910,911,912,913,914,915,895,
            896,758,759,897,902,920,903,908,907,761,
            701,1047,1050,1043,696,818,819,820,821,822,
            823,824,825,826,827,1061,919,770,781,783,
            1062,1064,608,1063,916,918,766,767,768,769,
            771,772,773,774,775,776,777,778,779,780,
            782,784,785,786,787,788,789,790,791,1052,
            1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,
            1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,
            1103,894,917,893,1048,757,921,904,905,1049,
            760,909,898,899,900,901,906,910,911,912,
            913,914,915,895,896,758,759,897,902,920,
            903,908,907,761,48,1047,1050,1043,696,818,
            819,820,821,822,823,824,825,826,827,1067,
            919,770,781,783,619,1070,1068,1069,916,918,
            766,767,768,769,771,772,773,774,775,776,
            777,778,779,780,782,784,785,786,787,788,
            789,790,791,1052,1083,1084,1085,1086,1087,1088,
            1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,
            1099,1100,1101,1102,1103,894,917,893,1048,757,
            921,904,905,1049,760,909,898,899,900,901,
            906,910,911,912,913,914,915,895,896,758,
            759,897,902,920,903,908,907,761,337,1047,
            1050,1043,696,818,819,820,821,822,823,824,
            825,826,827,1073,919,770,781,783,1075,1076,
            1074,630,916,918,766,767,768,769,771,772,
            773,774,775,776,777,778,779,780,782,784,
            785,786,787,788,789,790,791,1052,1083,1084,
            1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,
            1095,1096,1097,1098,1099,1100,1101,1102,1103,894,
            917,893,1048,757,921,904,905,1049,760,909,
            898,899,900,901,906,910,911,912,913,914,
            915,895,896,758,759,897,902,920,903,908,
            907,761,696,1047,1050,1043,696,818,819,820,
            821,822,823,824,825,826,827,644,919,770,
            781,783,1056,1058,1055,1057,916,918,766,767,
            768,769,771,772,773,774,775,776,777,778,
            779,780,782,784,785,786,787,788,789,790,
            791,1052,1083,1084,1085,1086,1087,1088,1089,1090,
            1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,
            1101,1102,1103,894,917,893,1048,757,921,904,
            905,1049,760,909,898,899,900,901,906,910,
            911,912,913,914,915,895,896,758,759,897,
            902,920,903,908,907,761,696,1047,1050,1043,
            696,597,597,597,597,597,597,597,597,597,
            597,2356,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            696,597,597,597,696,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,1836,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,696,597,597,597,696,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,1940,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,696,597,
            597,597,696,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            2044,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,696,597,597,597,696,818,819,820,
            821,822,823,824,825,826,827,1079,919,770,
            781,783,1081,696,1080,1082,916,918,766,767,
            768,769,771,772,773,774,775,776,777,778,
            779,780,782,784,785,786,787,788,789,790,
            791,1052,1083,1084,1085,1086,1087,1088,1089,1090,
            1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,
            1101,1102,1103,894,917,893,1048,757,921,904,
            905,1049,760,909,898,899,900,901,906,910,
            911,912,913,914,915,895,896,758,759,897,
            902,920,903,908,907,761,696,1047,1050,1043,
            408,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,696,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            597,597,597,597,597,597,597,597,597,597,
            696,597,597,597,696,818,819,820,821,822,
            823,824,825,826,827,796,919,770,781,783,
            795,804,805,809,916,918,766,767,768,769,
            771,772,773,774,775,776,777,778,779,780,
            782,784,785,786,787,788,789,790,791,764,
            792,793,794,797,798,799,800,801,802,803,
            806,807,808,810,811,812,813,814,815,816,
            817,894,917,893,745,757,921,904,905,742,
            760,909,898,899,900,901,906,910,911,912,
            913,914,915,895,896,758,759,897,902,920,
            903,908,907,761,765,696,818,819,820,821,
            822,823,824,825,826,827,796,919,770,781,
            783,795,804,805,809,916,918,766,767,768,
            769,771,772,773,774,775,776,777,778,779,
            780,782,784,785,786,787,788,789,790,791,
            764,792,793,794,797,798,799,800,801,802,
            803,806,807,808,810,811,812,813,814,815,
            816,817,894,917,893,746,757,921,904,905,
            707,760,909,898,899,900,901,906,910,911,
            912,913,914,915,895,896,758,759,897,902,
            920,903,908,907,761,765,10,818,819,820,
            821,822,823,824,825,826,827,796,890,770,
            781,783,795,804,805,809,887,889,766,767,
            768,769,771,772,773,774,775,776,777,778,
            779,780,782,784,785,786,787,788,789,790,
            791,764,792,793,794,797,798,799,800,801,
            802,803,806,807,808,810,811,812,813,814,
            815,816,817,864,888,863,966,965,892,875,
            876,865,968,880,869,870,871,872,877,881,
            882,883,884,885,886,866,867,696,696,868,
            873,891,874,879,878,969,765,696,970,696,
            818,819,820,821,822,823,824,825,826,827,
            796,947,770,781,783,795,804,805,809,944,
            946,766,767,768,769,771,772,773,774,775,
            776,777,778,779,780,782,784,785,786,787,
            788,789,790,791,764,792,793,794,797,798,
            799,800,801,802,803,806,807,808,810,811,
            812,813,814,815,816,817,923,945,922,927,
            982,949,934,935,924,1011,937,928,929,930,
            931,936,938,939,940,941,942,943,925,926,
            1012,1013,953,932,948,933,557,984,590,765,
            696,818,819,820,821,822,823,824,825,826,
            827,796,947,770,781,783,795,804,805,809,
            944,946,766,767,768,769,771,772,773,774,
            775,776,777,778,779,780,782,784,785,786,
            787,788,789,790,791,764,792,793,794,797,
            798,799,800,801,802,803,806,807,808,810,
            811,812,813,814,815,816,817,923,945,922,
            927,982,949,934,935,924,1011,937,928,929,
            930,931,936,938,939,940,941,942,943,925,
            926,1012,1013,953,932,948,933,557,699,696,
            765,696,818,819,820,821,822,823,824,825,
            826,827,796,717,770,781,783,795,804,805,
            586,469,504,766,767,768,769,771,772,773,
            774,775,776,777,778,779,780,782,784,785,
            786,787,788,789,790,791,764,792,793,794,
            797,798,799,800,801,802,803,806,807,808,
            810,811,812,813,814,815,816,817,551,487,
            515,711,757,696,453,481,537,760,726,427,
            463,454,1009,730,723,724,721,722,736,727,
            713,714,758,759,444,696,696,696,696,416,
            761,765,514,696,700,1021,472,323,818,819,
            820,821,822,823,824,825,826,827,796,947,
            770,781,783,795,804,805,809,944,946,766,
            767,768,769,771,772,773,774,775,776,777,
            778,779,780,782,784,785,786,787,788,789,
            790,791,764,792,793,794,797,798,799,800,
            801,802,803,806,807,808,810,811,812,813,
            814,815,816,817,923,945,922,927,978,949,
            934,935,924,1014,937,928,929,930,931,936,
            938,939,940,941,942,943,925,926,1015,1016,
            696,932,948,933,557,951,113,765,293,818,
            819,820,821,822,823,824,825,826,827,796,
            947,770,781,783,795,804,805,809,944,946,
            766,767,768,769,771,772,773,774,775,776,
            777,778,779,780,782,784,785,786,787,788,
            789,790,791,764,792,793,794,797,798,799,
            800,801,802,803,806,807,808,810,811,812,
            813,814,815,816,817,923,945,922,927,982,
            949,934,935,924,1011,937,928,929,930,931,
            936,938,939,940,941,942,943,925,926,1012,
            1013,953,932,948,933,557,695,615,765,324,
            818,819,820,821,822,823,824,825,826,827,
            796,947,770,781,783,795,804,805,809,944,
            946,766,767,768,769,771,772,773,774,775,
            776,777,778,779,780,782,784,785,786,787,
            788,789,790,791,764,792,793,794,797,798,
            799,800,801,802,803,806,807,808,810,811,
            812,813,814,815,816,817,923,945,922,927,
            978,949,934,935,924,1014,937,928,929,930,
            931,936,938,939,940,941,942,943,925,926,
            1015,1016,696,932,948,933,557,951,696,765,
            294,818,819,820,821,822,823,824,825,826,
            827,796,947,770,781,783,795,804,805,809,
            944,946,766,767,768,769,771,772,773,774,
            775,776,777,778,779,780,782,784,785,786,
            787,788,789,790,791,764,792,793,794,797,
            798,799,800,801,802,803,806,807,808,810,
            811,812,813,814,815,816,817,923,945,922,
            927,982,949,934,935,924,1011,937,928,929,
            930,931,936,938,939,940,941,942,943,925,
            926,1012,1013,953,932,948,933,557,696,696,
            765,696,818,819,820,821,822,823,824,825,
            826,827,796,947,770,781,783,795,804,805,
            809,944,946,766,767,768,769,771,772,773,
            774,775,776,777,778,779,780,782,784,785,
            786,787,788,789,790,791,764,792,793,794,
            797,798,799,800,801,802,803,806,807,808,
            810,811,812,813,814,815,816,817,923,945,
            922,927,974,949,934,935,924,696,937,928,
            929,930,931,936,938,939,940,941,942,943,
            925,926,1018,638,955,932,948,933,957,956,
            38,765,696,818,819,820,821,822,823,824,
            825,826,827,796,696,770,781,783,795,804,
            805,809,1000,622,766,767,768,769,771,772,
            773,774,775,776,777,778,779,780,782,784,
            785,786,787,788,789,790,791,764,792,793,
            794,797,798,799,800,801,802,803,806,807,
            808,810,811,812,813,814,815,816,817,993,
            623,992,994,735,696,696,696,995,696,307,
            16,1,818,819,820,821,822,823,824,825,
            826,827,796,596,770,781,783,795,804,805,
            809,696,765,766,767,768,769,771,772,773,
            774,775,776,777,778,779,780,782,784,785,
            786,787,788,789,790,791,764,792,793,794,
            797,798,799,800,801,802,803,806,807,808,
            810,811,812,813,814,815,816,817,696,696,
            570,696,35,862,696,696,696,696,696,634,
            295,818,819,820,821,822,823,824,825,826,
            827,796,604,770,781,783,795,804,805,809,
            696,765,766,767,768,769,771,772,773,774,
            775,776,777,778,779,780,782,784,785,786,
            787,788,789,790,791,764,792,793,794,797,
            798,799,800,801,802,803,806,807,808,810,
            811,812,813,814,815,816,817,696,36,696,
            696,696,862,41,818,819,820,821,822,823,
            824,825,826,827,853,308,854,13,1008,637,
            696,696,1105,661,696,696,12,1005,696,1002,
            765,696,818,819,820,821,822,823,824,825,
            826,827,696,818,819,820,821,822,823,824,
            825,826,827,58,818,819,820,821,822,823,
            824,825,826,827,57,818,819,820,821,822,
            823,824,825,826,827,60,818,819,820,821,
            822,823,824,825,826,827,59,818,819,820,
            821,822,823,824,825,826,827,757,497,20,
            477,32,760,19,33,14,696,696,42,696,
            696,719,113,1001,696,718,1010,758,759,853,
            720,854,616,3940,1007,761,725,626,696,696,
            303,300,696,641,113,696,696,696,696,696,
            642,733,998,997,696,696,696,696,696,1032,
            696,3172,696,696,696,696,696,696,696,696,
            696,696,696,696,696,696,696,1006,696,696,
            696,696,747,696,696,605
        };
    };
    public final static char termAction[] = TermAction.termAction;
    public final int termAction(int index) { return termAction[index]; }
    public final int asb(int index) { return 0; }
    public final int asr(int index) { return 0; }
    public final int nasb(int index) { return 0; }
    public final int nasr(int index) { return 0; }
    public final int terminalIndex(int index) { return 0; }
    public final int nonterminalIndex(int index) { return 0; }
    public final int scopePrefix(int index) { return 0;}
    public final int scopeSuffix(int index) { return 0;}
    public final int scopeLhs(int index) { return 0;}
    public final int scopeLa(int index) { return 0;}
    public final int scopeStateSet(int index) { return 0;}
    public final int scopeRhs(int index) { return 0;}
    public final int scopeState(int index) { return 0;}
    public final int inSymb(int index) { return 0;}
    public final String name(int index) { return null; }
    public final int getErrorSymbol() { return 0; }
    public final int getScopeUbound() { return 0; }
    public final int getScopeSize() { return 0; }
    public final int getMaxNameLength() { return 0; }

    public final static int
           NUM_STATES        = 65,
           NT_OFFSET         = 106,
           LA_STATE_OFFSET   = 1105,
           MAX_LA            = 6,
           NUM_RULES         = 409,
           NUM_NONTERMINALS  = 56,
           NUM_SYMBOLS       = 162,
           SEGMENT_SIZE      = 8192,
           START_STATE       = 410,
           IDENTIFIER_SYMBOL = 0,
           EOFT_SYMBOL       = 106,
           EOLT_SYMBOL       = 107,
           ACCEPT_ACTION     = 695,
           ERROR_ACTION      = 696;

    public final static boolean BACKTRACK = false;

    public final int getNumStates() { return NUM_STATES; }
    public final int getNtOffset() { return NT_OFFSET; }
    public final int getLaStateOffset() { return LA_STATE_OFFSET; }
    public final int getMaxLa() { return MAX_LA; }
    public final int getNumRules() { return NUM_RULES; }
    public final int getNumNonterminals() { return NUM_NONTERMINALS; }
    public final int getNumSymbols() { return NUM_SYMBOLS; }
    public final int getSegmentSize() { return SEGMENT_SIZE; }
    public final int getStartState() { return START_STATE; }
    public final int getStartSymbol() { return lhs[0]; }
    public final int getIdentifierSymbol() { return IDENTIFIER_SYMBOL; }
    public final int getEoftSymbol() { return EOFT_SYMBOL; }
    public final int getEoltSymbol() { return EOLT_SYMBOL; }
    public final int getAcceptAction() { return ACCEPT_ACTION; }
    public final int getErrorAction() { return ERROR_ACTION; }
    public final boolean isValidForParser() { return isValidForParser; }
    public final boolean getBacktrack() { return BACKTRACK; }

    public final int originalState(int state) { return 0; }
    public final int asi(int state) { return 0; }
    public final int nasi(int state) { return 0; }
    public final int inSymbol(int state) { return 0; }

    public final int ntAction(int state, int sym) {
        return baseAction[state + sym];
    }

    public final int tAction(int state, int sym) {
        int i = baseAction[state],
            k = i + sym;
        return termAction[termCheck[k] == sym ? k : i];
    }
    public final int lookAhead(int la_state, int sym) {
        int k = la_state + sym;
        return termAction[termCheck[k] == sym ? k : la_state];
    }
}
