/*
 * Copyright (c) 2006, 2009 Borland Software Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare - Xpand language syntax
 *     Artem Tikhomirov (Borland) - LALR grammar
 *                                - Migration to OCL expressions
 */
package org.eclipse.gmf.internal.xpand.parser;

public interface XpandLexersym {
    public final static int
      Char_CtlCharNotWS = 102,
      Char_LF = 91,
      Char_CR = 92,
      Char_HT = 76,
      Char_FF = 99,
      Char_a = 22,
      Char_b = 23,
      Char_c = 24,
      Char_d = 25,
      Char_e = 13,
      Char_f = 26,
      Char_g = 27,
      Char_h = 28,
      Char_i = 29,
      Char_j = 30,
      Char_k = 31,
      Char_l = 32,
      Char_m = 33,
      Char_n = 34,
      Char_o = 35,
      Char_p = 14,
      Char_q = 36,
      Char_r = 15,
      Char_s = 37,
      Char_t = 38,
      Char_u = 39,
      Char_v = 40,
      Char_w = 41,
      Char_x = 42,
      Char_y = 43,
      Char_z = 44,
      Char__ = 45,
      Char_A = 46,
      Char_B = 47,
      Char_C = 48,
      Char_D = 16,
      Char_E = 11,
      Char_F = 49,
      Char_G = 50,
      Char_H = 51,
      Char_I = 52,
      Char_J = 53,
      Char_K = 54,
      Char_L = 55,
      Char_M = 17,
      Char_N = 18,
      Char_O = 56,
      Char_P = 57,
      Char_Q = 58,
      Char_R = 19,
      Char_S = 59,
      Char_T = 60,
      Char_U = 61,
      Char_V = 62,
      Char_W = 63,
      Char_X = 64,
      Char_Y = 65,
      Char_Z = 66,
      Char_0 = 1,
      Char_1 = 2,
      Char_2 = 3,
      Char_3 = 4,
      Char_4 = 5,
      Char_5 = 6,
      Char_6 = 7,
      Char_7 = 8,
      Char_8 = 9,
      Char_9 = 10,
      Char_AfterASCIINotAcute = 100,
      Char_Space = 71,
      Char_DoubleQuote = 93,
      Char_SingleQuote = 98,
      Char_Percent = 94,
      Char_VerticalBar = 77,
      Char_Exclamation = 78,
      Char_AtSign = 79,
      Char_BackQuote = 80,
      Char_Acute = 105,
      Char_Tilde = 81,
      Char_Sharp = 95,
      Char_DollarSign = 72,
      Char_Ampersand = 96,
      Char_Caret = 73,
      Char_Colon = 74,
      Char_SemiColon = 82,
      Char_BackSlash = 97,
      Char_LeftBrace = 83,
      Char_RightBrace = 84,
      Char_LeftBracket = 85,
      Char_RightBracket = 86,
      Char_QuestionMark = 87,
      Char_Comma = 88,
      Char_Dot = 20,
      Char_LessThan = 68,
      Char_GreaterThan = 21,
      Char_Plus = 69,
      Char_Minus = 67,
      Char_Slash = 75,
      Char_Star = 70,
      Char_LeftParen = 89,
      Char_RightParen = 90,
      Char_Equal = 12,
      Char_LG = 104,
      Char_RG = 101,
      Char_AfterASCII = 103,
      Char_EOF = 106;

      public final static String orderedTerminalSymbols[] = {
                 "",
                 "0",
                 "1",
                 "2",
                 "3",
                 "4",
                 "5",
                 "6",
                 "7",
                 "8",
                 "9",
                 "E",
                 "Equal",
                 "e",
                 "p",
                 "r",
                 "D",
                 "M",
                 "N",
                 "R",
                 "Dot",
                 "GreaterThan",
                 "a",
                 "b",
                 "c",
                 "d",
                 "f",
                 "g",
                 "h",
                 "i",
                 "j",
                 "k",
                 "l",
                 "m",
                 "n",
                 "o",
                 "q",
                 "s",
                 "t",
                 "u",
                 "v",
                 "w",
                 "x",
                 "y",
                 "z",
                 "_",
                 "A",
                 "B",
                 "C",
                 "F",
                 "G",
                 "H",
                 "I",
                 "J",
                 "K",
                 "L",
                 "O",
                 "P",
                 "Q",
                 "S",
                 "T",
                 "U",
                 "V",
                 "W",
                 "X",
                 "Y",
                 "Z",
                 "Minus",
                 "LessThan",
                 "Plus",
                 "Star",
                 "Space",
                 "DollarSign",
                 "Caret",
                 "Colon",
                 "Slash",
                 "HT",
                 "VerticalBar",
                 "Exclamation",
                 "AtSign",
                 "BackQuote",
                 "Tilde",
                 "SemiColon",
                 "LeftBrace",
                 "RightBrace",
                 "LeftBracket",
                 "RightBracket",
                 "QuestionMark",
                 "Comma",
                 "LeftParen",
                 "RightParen",
                 "LF",
                 "CR",
                 "DoubleQuote",
                 "Percent",
                 "Sharp",
                 "Ampersand",
                 "BackSlash",
                 "SingleQuote",
                 "FF",
                 "AfterASCIINotAcute",
                 "RG",
                 "CtlCharNotWS",
                 "AfterASCII",
                 "LG",
                 "Acute",
                 "EOF"
             };

    public final static boolean isValidForParser = true;
}
