/*
 * Copyright (c) 2006, 2009 Borland Software Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare - Xpand language syntax
 *     Artem Tikhomirov (Borland) - LALR grammar
 *                                - Migration to OCL expressions
 */
package org.eclipse.gmf.internal.xpand.parser;

public class XpandParserprs implements lpg.lpgjavaruntime.ParseTable, XpandParsersym {

    public interface IsKeyword {
        public final static byte isKeyword[] = {0,
            0,0,0,0,0,1,1,1,1,1,
            1,1,1,1,0,0,0,0,0,0,
            1,1,1,1,1,0,0,1,1,1,
            1,0,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,0,0,1,1,1,1,1,1,1,
            1,1,1,0,1,1,1,1,1,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,1,1,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,1,1,1,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,1,1,1,1,
            1,1,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,1,1,
            1,0,0,1,1,1,0,0,1,1,
            0,0,0,0,0,0,0,0,0,0,
            1,1,0,0,0,0,0,0,1,0,
            0,1,1,1,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,1,1,1,0,0,0,
            0,1,1,1,0,0,0,0
        };
    };
    public final static byte isKeyword[] = IsKeyword.isKeyword;
    public final boolean isKeyword(int index) { return isKeyword[index] != 0; }

    public interface BaseCheck {
        public final static short baseCheck[] = {0,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,3,3,1,1,
            3,3,3,3,3,3,1,1,3,3,
            3,3,1,1,3,3,3,3,3,3,
            3,3,1,1,1,3,3,3,3,1,
            1,3,3,3,3,1,1,2,2,1,
            2,2,4,6,1,1,1,1,3,2,
            2,1,1,1,1,1,1,1,1,1,
            1,1,1,1,3,0,1,1,1,1,
            1,1,1,3,3,4,1,1,1,1,
            1,0,1,1,3,1,1,3,2,3,
            1,1,1,1,1,4,1,1,1,1,
            1,1,1,1,2,2,2,2,1,1,
            4,4,4,4,4,4,4,4,4,4,
            4,1,3,5,6,8,1,3,5,3,
            1,1,1,1,4,4,0,1,1,3,
            1,1,3,3,1,1,5,5,5,5,
            5,5,5,5,5,5,5,5,5,5,
            5,5,5,5,5,5,2,2,0,1,
            0,1,1,3,5,0,1,2,3,5,
            5,0,1,1,3,1,1,3,1,1,
            3,5,5,3,1,7,5,7,6,5,
            4,3,2,1,1,3,4,4,3,2,
            2,1,3,1,1,1,1,1,1,1,
            1,1,1,1,3,5,5,5,1,3,
            3,2,1,4,4,1,6,4,1,1,
            1,1,3,1,0,1,3,2,1,1,
            1,1,1,1,1,1,1,4,4,2,
            1,3,5,0,1,2,0,1,7,5,
            7,1,1,1,0,3,5,4,4,0,
            1,0,2,0,2,4,0,2,4,6,
            9,11,9,2,2,0,1,2,6,9,
            1,3,1,2,2,0,3,1,1,1,
            1,1,1,3,0,3,0,1,1,1,
            1,2,3,5,6,0,3,1,1,5,
            0,1,8,0,2,0,2,6,0,4,
            0,2,6,10,0,1,-58,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -192,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-109,0,0,0,0,0,
            0,0,0,-140,0,0,0,-175,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-160,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-324,-28,0,0,0,
            0,-29,0,-6,0,0,0,0,0,0,
            -30,-4,-12,-11,-166,0,0,0,0,0,
            0,-123,-2,0,-122,0,0,-163,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-9,-14,0,0,0,0,
            0,0,0,0,0,0,0,0,-15,-16,
            0,-3,0,0,0,0,0,0,-13,0,
            0,0,0,-167,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-213,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-18,-19,0,
            0,-218,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-23,-26,0,0,
            -219,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-36,-37,0,0,-220,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-38,-39,0,0,-221,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-40,-41,0,0,-222,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-42,-43,0,0,-223,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-44,-46,0,0,-224,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -48,-50,0,0,-225,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-57,
            -59,0,0,-226,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-61,-62,
            0,0,-227,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-64,-66,0,
            0,-228,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-67,-92,0,0,
            -229,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-93,-94,0,0,-230,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-96,-97,0,0,-231,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-98,-99,0,0,-238,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-100,-101,0,0,-243,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-136,-391,0,0,-326,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -45,-102,0,0,-335,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-103,-7,
            0,-104,-107,0,0,0,0,-108,-170,0,
            -24,-25,0,0,0,-111,-112,-49,0,0,
            0,0,-349,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-171,0,0,0,0,0,0,0,0,
            -8,0,0,0,0,0,-113,0,-114,-110,
            0,-247,-47,-33,-253,-132,-17,-5,-134,-10,
            0,0,-350,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-115,-116,0,-117,-118,0,-119,-120,-20,
            0,-217,-121,0,-288,-129,-133,-137,-138,-139,
            0,0,-366,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-141,0,
            0,-367,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -212,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-180,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-285,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-197,-68,0,-320,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-368,-142,-143,-144,-145,-146,
            0,0,0,-147,-148,-149,0,-150,-151,-201,
            -152,-210,-286,-21,0,0,-338,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -193,0,0,0,0,0,0,0,0,-293,
            0,0,-360,0,-339,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-22,-27,0,0,0,0,0,0,-395,
            -191,0,-340,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-153,0,0,
            0,-154,-155,0,0,0,-396,-156,0,0,
            -341,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-405,-157,0,-158,-159,-162,
            0,0,0,-414,-165,-172,-427,0,-342,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-194,0,0,-196,-198,0,0,0,
            0,0,0,-200,-208,0,-343,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-202,0,-204,-205,-206,-207,-232,-233,-236,
            -237,-239,-295,0,-344,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-240,
            0,-241,-244,-245,-246,-256,-257,-258,-259,-260,
            -336,0,-345,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-261,0,-262,
            -263,-264,-265,-266,-267,-268,-269,-270,-407,0,
            -346,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-271,0,-272,-274,-275,
            -276,-277,-278,-279,-280,-281,-409,0,-347,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-282,0,-283,-284,-287,-289,-290,
            -292,-296,-298,-299,-300,0,-348,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -301,-302,0,-303,-304,-305,-306,-307,-308,-309,
            -310,-311,-312,0,-363,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-181,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-72,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -209,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-327,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -410,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-412,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-313,
            -314,-315,-316,-317,-322,-325,-328,-329,-330,-331,
            -332,-333,-351,-355,-356,-362,-364,-369,-370,-371,
            -372,-373,-374,0,-53,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-71,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-124,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-125,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -126,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-127,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-128,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-188,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-189,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -199,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-211,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-234,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-273,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-294,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -318,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-319,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-323,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-352,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-353,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -354,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-359,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-361,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-365,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-403,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -406,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-408,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-413,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-416,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-424,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -425,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-426,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-184,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-185,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-186,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-187,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-177,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-178,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -179,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-182,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-183,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-176,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-173,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-174,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-69,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-70,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-235,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-169,0,-73,-195,0,0,0,
            -375,0,-31,0,0,0,-376,-32,0,0,
            0,-377,-378,-379,-423,-1,-74,-415,-357,-392,
            -75,-380,-34,0,0,0,-381,-60,0,0,
            0,-382,-383,-384,-164,-321,-358,0,-385,-386,
            0,0,-387,0,0,0,0,0,0,-388,
            -130,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-389,-390,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-76,0,0,0,0,
            0,0,-168,0,0,-393,0,0,0,-394,
            0,0,0,0,0,-242,-397,0,0,-398,
            0,0,0,0,0,0,0,-255,0,0,
            0,-35,0,0,0,0,-51,0,0,0,
            0,-52,0,0,0,-400,0,-54,0,0,
            0,0,-55,0,0,0,0,0,0,0,
            0,0,-63,0,0,0,-297,-65,0,0,
            0,0,-131,0,0,0,-291,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-77,0,0,0,0,
            0,0,0,0,0,0,-135,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-190,0,0,0,
            0,-203,0,0,0,-401,-214,0,0,0,
            0,-215,0,0,0,-402,-216,0,0,0,
            -404,-411,0,0,0,0,0,0,0,0,
            -56,-161,-334,-417,-78,-79,-80,-81,-82,-83,
            -84,-85,-86,0,-87,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-88,0,0,0,0,
            0,0,0,0,0,0,0,0,-89,0,
            0,-90,-91,-418,-95,-105,-419,0,-106,0,
            -248,-249,-250,-251,-252,-254,-420,-337,-399,-421,
            -422,-428,-429,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0
        };
    };
    public final static short baseCheck[] = BaseCheck.baseCheck;
    public final int baseCheck(int index) { return baseCheck[index]; }
    public final static short rhs[] = baseCheck;
    public final int rhs(int index) { return rhs[index]; };

    public interface BaseAction {
        public final static char baseAction[] = {
            103,5,5,5,5,5,5,5,5,5,
            5,5,5,5,5,5,5,5,5,5,
            5,6,6,41,41,42,43,42,43,39,
            40,39,39,39,40,40,40,37,38,37,
            38,37,38,35,36,35,36,35,36,35,
            36,35,36,32,34,33,34,33,34,33,
            30,31,30,31,30,31,16,28,16,16,
            17,17,17,17,17,18,18,18,18,18,
            19,19,4,4,4,1,1,1,1,1,
            1,1,1,1,2,2,106,106,20,20,
            20,20,20,20,21,21,22,3,3,3,
            3,3,74,74,75,75,65,65,66,66,
            66,9,9,9,9,9,23,11,12,13,
            7,14,14,10,24,104,104,104,104,108,
            108,109,109,109,109,109,109,109,109,109,
            109,109,57,57,57,110,110,46,46,46,
            59,49,49,49,49,51,50,111,111,67,
            67,107,107,107,107,76,76,76,76,8,
            8,8,8,8,8,8,8,8,8,8,
            8,8,8,8,8,15,8,77,77,45,
            45,48,48,47,47,29,112,112,113,113,
            105,105,78,78,79,79,68,68,68,60,
            60,61,61,61,62,80,25,25,25,25,
            25,25,25,25,18,114,114,29,29,57,
            104,104,47,47,115,115,115,115,115,115,
            115,115,115,115,115,109,8,8,8,44,
            37,38,7,49,52,26,49,53,27,81,
            81,20,20,82,116,116,117,117,117,108,
            119,119,119,119,120,120,121,121,118,118,
            118,122,122,123,69,69,124,125,125,104,
            18,17,18,18,103,126,126,103,70,70,
            85,85,58,58,83,83,86,84,84,87,
            72,72,72,72,63,63,73,73,73,71,
            71,88,88,64,64,56,89,89,90,90,
            90,90,90,90,55,97,97,54,54,91,
            91,91,98,99,99,99,128,128,127,100,
            92,129,129,93,130,130,101,101,94,102,
            102,131,131,95,96,132,132,1,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,359,1812,
            24,1,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,359,1812,24,1757,335,595,338,339,
            340,341,342,343,3334,349,350,351,2041,82,
            1653,1308,5299,5296,4976,1357,77,101,102,121,
            122,123,125,78,60,465,1740,75,76,98,
            99,100,103,234,271,272,61,67,2639,59,
            337,595,338,339,340,341,342,343,232,349,
            350,351,1687,82,1653,1308,5299,5296,4976,1357,
            77,101,102,121,122,123,125,78,60,465,
            1740,75,76,98,99,100,103,234,271,272,
            61,67,1666,55,43,44,1667,1739,38,1737,
            30,1813,26,2469,1812,24,3517,3553,82,71,
            72,95,1842,1357,3274,269,270,121,122,123,
            125,1842,1931,3274,3,3239,82,114,116,2523,
            21,104,117,1930,2403,104,2468,2470,1687,82,
            1653,1308,5299,5296,4976,1357,77,101,102,121,
            122,123,125,78,60,465,1740,75,76,98,
            99,100,103,234,271,272,61,67,1666,55,
            43,44,1667,1739,38,1737,30,1813,26,2469,
            1812,24,311,660,659,3495,3394,2522,277,1161,
            421,311,660,659,307,660,659,309,584,3549,
            3557,583,3269,114,116,574,308,318,1650,117,
            583,769,2472,2470,125,82,1653,1308,5299,5296,
            4976,1357,77,101,102,121,122,123,125,78,
            60,465,1740,75,76,98,99,100,103,234,
            271,272,61,67,1666,55,43,44,1667,1739,
            38,1737,30,1813,26,203,1812,24,242,2171,
            582,2525,2524,196,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,203,1812,24,242,1758,1854,
            2525,2703,267,82,1653,1308,5299,5296,4976,1357,
            77,101,102,121,122,123,125,78,60,465,
            1740,75,76,98,99,100,103,234,271,272,
            61,67,1666,55,43,44,1667,1739,38,1737,
            30,1813,26,203,1812,24,242,1945,3266,2525,
            2755,338,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,203,1812,24,242,97,3271,2525,2756,
            409,82,1653,1308,5299,5296,4976,1357,77,101,
            102,121,122,123,125,78,60,465,1740,75,
            76,98,99,100,103,234,271,272,61,67,
            1666,55,43,44,1667,1739,38,1737,30,1813,
            26,203,1812,24,242,86,108,2525,2757,480,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            203,1812,24,242,3547,3299,2525,2758,551,82,
            1653,1308,5299,5296,4976,1357,77,101,102,121,
            122,123,125,78,60,465,1740,75,76,98,
            99,100,103,234,271,272,61,67,1666,55,
            43,44,1667,1739,38,1737,30,1813,26,203,
            1812,24,242,1843,1935,2525,2759,622,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,203,1812,
            24,242,2025,3497,2525,2760,693,82,1653,1308,
            5299,5296,4976,1357,77,101,102,121,122,123,
            125,78,60,465,1740,75,76,98,99,100,
            103,234,271,272,61,67,1666,55,43,44,
            1667,1739,38,1737,30,1813,26,203,1812,24,
            242,3393,3481,2525,2761,764,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,203,1812,24,242,
            1765,3577,2525,2762,835,82,1653,1308,5299,5296,
            4976,1357,77,101,102,121,122,123,125,78,
            60,465,1740,75,76,98,99,100,103,234,
            271,272,61,67,1666,55,43,44,1667,1739,
            38,1737,30,1813,26,203,1812,24,242,3543,
            1932,2525,2763,906,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,203,1812,24,242,121,3229,
            2525,3070,977,82,1653,1308,5299,5296,4976,1357,
            77,101,102,121,122,123,125,78,60,465,
            1740,75,76,98,99,100,103,234,271,272,
            61,67,1666,55,43,44,1667,1739,38,1737,
            30,1813,26,203,1812,24,242,2180,3201,2525,
            3071,1048,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,203,1812,24,242,3583,3407,2525,3072,
            1119,82,1653,1308,5299,5296,4976,1357,77,101,
            102,121,122,123,125,78,60,465,1740,75,
            76,98,99,100,103,234,271,272,61,67,
            1666,55,43,44,1667,1739,38,1737,30,1813,
            26,203,1812,24,242,1852,3584,2525,3073,1190,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            203,1812,24,242,3585,3587,2525,3074,1261,82,
            1653,1308,5299,5296,4976,1357,77,101,102,121,
            122,123,125,78,60,465,1740,75,76,98,
            99,100,103,234,271,272,61,67,1666,55,
            43,44,1667,1739,38,1737,30,1813,26,203,
            1812,24,242,3590,3592,2525,3075,1332,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,203,1812,
            24,242,3609,3856,2525,3076,1403,82,1653,1308,
            5299,5296,4976,1357,77,101,102,121,122,123,
            125,78,60,465,1740,75,76,98,99,100,
            103,234,271,272,61,67,1666,55,43,44,
            1667,1739,38,1737,30,1813,26,203,1812,24,
            242,104,3593,2525,3087,2195,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,291,1812,24,3597,
            1931,169,3598,3599,355,1161,377,1160,2020,3553,
            82,1766,1766,2636,2466,2467,3359,3226,3402,161,
            964,1013,3091,1855,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,216,1812,24,1062,162,163,
            263,266,3553,82,327,327,2638,3090,333,219,
            220,76,332,315,325,324,1650,3430,646,72,
            1947,214,3531,104,1766,3532,104,111,3534,104,
            3534,5023,5048,1855,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,216,1812,24,1161,377,1210,
            1161,377,2462,1161,377,2464,645,327,313,2356,
            817,3077,3588,3265,3082,1928,2185,328,2190,3600,
            3534,214,3683,3602,2754,3696,3601,3605,3507,2188,
            3208,5049,5048,1474,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,203,1812,24,242,316,2032,
            2525,5206,1545,82,1653,1308,5299,5296,4976,1357,
            77,101,102,121,122,123,125,78,60,465,
            1740,75,76,98,99,100,103,234,271,272,
            61,67,1666,55,43,44,1667,1739,38,1737,
            30,1813,26,203,1812,24,242,5017,2752,2525,
            5216,1616,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,225,1812,24,231,2041,82,1653,1308,
            5299,5296,4976,1357,77,101,102,121,122,123,
            125,78,60,465,1740,75,76,98,99,100,
            103,234,271,272,61,67,1666,55,51,52,
            1667,5137,1616,82,1653,1308,5299,5296,4976,1357,
            77,101,102,121,122,123,125,78,60,465,
            1740,75,76,98,99,100,103,234,271,272,
            61,67,1666,55,43,44,1667,1739,38,1737,
            30,1813,26,203,1812,24,242,104,2186,3084,
            1771,82,1653,1308,5299,5296,4976,1357,77,101,
            102,121,122,123,125,78,60,465,1740,75,
            76,98,99,100,103,234,271,272,61,67,
            1666,55,43,44,1667,1739,38,1737,30,1813,
            26,2469,1812,24,1552,3819,3175,3381,3428,3432,
            3610,1161,377,1825,3612,3623,3625,235,3627,3630,
            104,3632,3681,104,3534,115,116,2195,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,152,1812,
            24,3668,1828,4987,1161,377,2701,1161,377,3085,
            104,236,572,104,4981,2195,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,152,1812,24,298,
            4107,4987,3534,3534,1161,377,3086,1161,377,5087,
            104,3227,4992,2195,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,152,1812,24,170,3634,4987,
            581,319,3636,3638,1161,377,372,104,3640,2697,
            4993,2195,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,152,1812,24,3681,3642,4987,3644,3646,
            3652,1161,377,4998,104,3660,3648,104,4994,2195,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            152,1812,24,3656,5294,4987,3650,3665,1161,377,
            5311,1161,377,5313,3670,3227,5002,2195,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,152,1812,
            24,208,3675,4987,3676,3420,3677,3678,3685,3687,
            3690,3511,3689,3227,5007,2195,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,152,1812,24,209,
            3691,4987,3688,3308,3692,3697,3698,3700,3702,3704,
            3706,3227,5012,2195,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,152,1812,24,3093,3708,4987,
            3710,3712,3714,3716,3718,3720,3722,3726,3728,3227,
            5013,2195,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,152,1812,24,5297,3732,4987,3734,3392,
            3468,1925,2018,3238,3268,3571,3574,3227,5014,2195,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            152,1812,24,5310,3575,4987,3736,3419,3740,3744,
            3107,3730,3745,3746,3751,3754,5019,2195,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,152,1812,
            24,3755,3762,4987,3738,3770,3771,3774,3775,3778,
            3781,3782,3785,3786,5020,1616,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,225,1812,24,229,
            2041,82,1653,1308,5299,5296,4976,1357,77,101,
            102,121,122,123,125,78,60,465,1740,75,
            76,98,99,100,103,234,271,272,61,67,
            1666,55,49,50,1667,5309,1616,82,1653,1308,
            5299,5296,4976,1357,77,101,102,121,122,123,
            125,78,60,465,1740,75,76,98,99,100,
            103,234,271,272,61,67,1666,55,43,44,
            1667,1739,38,1737,30,1813,26,474,1812,24,
            233,1616,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,237,1812,24,238,1616,82,1653,1308,
            5299,5296,4976,1357,77,101,102,121,122,123,
            125,78,60,465,1740,75,76,98,99,100,
            103,234,271,272,61,67,1666,55,43,44,
            1667,1739,38,1737,30,1813,26,204,1812,24,
            243,1616,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,153,1812,24,239,1948,82,1653,1308,
            5299,5296,4976,1357,77,101,102,121,122,123,
            125,78,60,465,1740,75,76,98,99,100,
            103,234,271,272,61,67,1666,55,43,44,
            1667,1739,38,1737,30,1813,26,216,1812,24,
            3789,3790,3793,3794,3797,3798,3801,3739,3804,3806,
            3808,3810,3758,3765,3533,3802,3817,3818,3821,3360,
            3824,3545,1689,3469,215,2041,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,224,1812,24,2041,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            1830,1812,24,2041,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,352,1812,24,2041,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,4977,1812,
            24,2041,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,2406,1812,24,2041,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,2057,1812,24,2041,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            2407,1812,24,2041,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,223,1812,24,2041,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,222,1812,
            24,2041,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,2700,1812,24,2041,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,160,1812,24,2041,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            119,1812,24,2041,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,3083,1812,24,2041,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,205,1812,
            24,2041,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,120,1812,24,2041,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,118,1812,24,2041,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            273,1812,24,2041,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,159,1812,24,2041,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,1553,1812,
            24,2041,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,354,1812,24,2041,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,2297,1812,24,2041,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            5090,1812,24,2041,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,5116,1812,24,2041,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,5234,1812,
            24,2041,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,292,1812,24,2041,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,5307,1812,24,2041,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,1813,26,
            367,1812,24,2041,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,43,44,1667,1739,38,
            1737,30,1813,26,4995,1812,24,2041,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,1739,38,1737,30,1813,26,293,1812,
            24,2041,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,1739,38,1737,30,
            1813,26,5312,1812,24,2041,82,1653,1308,5299,
            5296,4976,1357,77,101,102,121,122,123,125,
            78,60,465,1740,75,76,98,99,100,103,
            234,271,272,61,67,1666,55,43,44,1667,
            1739,38,1737,30,1813,26,154,1812,24,2041,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,1737,30,2644,28,
            2041,82,1653,1308,5299,5296,4976,1357,77,101,
            102,121,122,123,125,78,60,465,1740,75,
            76,98,99,100,103,234,271,272,61,67,
            1666,55,43,44,1667,1739,38,2645,36,2041,
            82,1653,1308,5299,5296,4976,1357,77,101,102,
            121,122,123,125,78,60,465,1740,75,76,
            98,99,100,103,234,271,272,61,67,1666,
            55,43,44,1667,1739,38,2646,35,2041,82,
            1653,1308,5299,5296,4976,1357,77,101,102,121,
            122,123,125,78,60,465,1740,75,76,98,
            99,100,103,234,271,272,61,67,1666,55,
            43,44,1667,1739,38,2694,34,2041,82,1653,
            1308,5299,5296,4976,1357,77,101,102,121,122,
            123,125,78,60,465,1740,75,76,98,99,
            100,103,234,271,272,61,67,1666,55,43,
            44,1667,2641,261,2041,82,1653,1308,5299,5296,
            4976,1357,77,101,102,121,122,123,125,78,
            60,465,1740,75,76,98,99,100,103,234,
            271,272,61,67,1666,55,43,44,1667,2642,
            42,2041,82,1653,1308,5299,5296,4976,1357,77,
            101,102,121,122,123,125,78,60,465,1740,
            75,76,98,99,100,103,234,271,272,61,
            67,1666,55,43,44,1667,2643,40,2041,82,
            1653,1308,5299,5296,4976,1357,77,101,102,121,
            122,123,125,78,60,465,1740,75,76,98,
            99,100,103,234,271,272,61,67,1666,55,
            47,48,1667,2041,82,1653,1308,5299,5296,4976,
            1357,77,101,102,121,122,123,125,78,60,
            465,1740,75,76,98,99,100,103,234,271,
            272,61,67,1666,55,45,46,1667,2041,82,
            1653,1308,5299,5296,4976,1357,77,101,102,121,
            122,123,125,78,60,465,1740,75,76,98,
            99,100,103,234,271,272,61,67,2640,57,
            2041,82,1653,1308,5299,5296,4976,1357,77,101,
            102,121,122,123,125,78,64,465,1740,75,
            76,98,99,100,103,234,271,272,65,67,
            2041,82,1653,1308,5299,5296,4976,1357,77,101,
            102,121,122,123,125,78,62,465,1740,75,
            76,98,99,100,103,234,271,272,63,67,
            3105,82,1653,1308,5299,5296,4976,1357,77,101,
            102,121,122,123,125,78,69,465,1740,75,
            76,98,99,100,103,234,271,272,3105,82,
            1653,1308,5299,5296,4976,1357,77,101,102,121,
            122,123,125,78,68,465,1740,75,76,98,
            99,100,103,234,271,272,2111,82,1653,1308,
            5299,5296,4976,1357,77,101,102,121,122,123,
            125,78,68,465,1740,75,76,98,99,100,
            103,234,271,272,3174,82,3581,3240,5305,21,
            5306,3825,176,71,161,964,1013,3546,3479,161,
            964,1013,3828,3831,3835,3875,3291,3581,3696,3812,
            3856,3581,3836,3516,161,964,1013,3839,3516,161,
            964,1013,3840,3843,3847,3453,2186,3816,241,3848,
            3851,1879,1357,3852,269,270,121,122,123,125,
            3832,3440,1062,162,163,263,266,1601,162,163,
            263,266,2106,333,219,220,2107,331,3844,3855,
            1745,175,1062,162,163,263,266,1062,162,163,
            263,266,174,333,219,220,3581,331,333,219,
            220,867,332,3307,82,173,3858,5305,21,5304,
            3259,176,136,139,140,2414,2113,3859,137,2529,
            3860,1063,279,2527,2526,5098,2522,276,2337,593,
            370,2354,3479,161,964,1013,2123,3479,161,964,
            1013,2108,3479,161,964,1013,3862,240,3479,161,
            964,1013,304,3479,161,964,1013,2357,344,5000,
            278,2520,5086,3479,161,964,1013,3292,3479,161,
            964,1013,290,3479,161,964,1013,3483,5080,1742,
            175,1743,162,163,263,266,1259,162,163,263,
            266,1307,162,163,263,266,3581,1815,162,163,
            263,266,1816,162,163,263,266,3479,161,964,
            1013,230,1746,162,163,263,266,1749,162,163,
            263,266,2120,162,163,263,266,3479,161,964,
            1013,2414,3479,161,964,1013,3863,3479,161,964,
            1013,2109,3479,161,964,1013,3864,3479,161,964,
            1013,3867,3479,161,964,1013,2465,162,163,263,
            266,2026,2186,3227,3868,3581,3581,3581,3581,3581,
            3581,3581,3581,3581,346,3581,2696,162,163,263,
            266,2180,162,163,263,266,2704,162,163,263,
            266,2705,162,163,263,266,2751,162,163,263,
            266,218,162,163,263,266,3581,169,172,169,
            2110,2114,2115,2116,2118,2119,2121,2288,2292,3581,
            2293,171,3581,3581,3869,1845,1937,3871,1823,3581,
            3089,3581,3581,3581,3581,3581,3581,3870,2337,3448,
            3873,3874,3876,3877,5359,5359,5359,5359,5359,5359,
            5359,2298,5359,5359,5359,5359,5359,5359,5359,5359,
            5359,5359,5359,5359,2346,5359,5359,2348,2349,2471,
            2350,81,1818,5359,2355,5359,3078,3079,2350,3080,
            3081,198,255,228,5359,5359,3088,5359,5359
        };
    };
    public final static char baseAction[] = BaseAction.baseAction;
    public final int baseAction(int index) { return baseAction[index]; }
    public final static char lhs[] = baseAction;
    public final int lhs(int index) { return lhs[index]; };

    public interface TermCheck {
        public final static char termCheck[] = {0,
            0,1,0,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            0,0,0,3,4,0,6,7,8,9,
            10,11,12,13,14,0,1,16,17,18,
            19,21,22,23,24,25,0,0,2,97,
            98,101,27,0,34,35,36,0,1,0,
            0,111,112,3,4,115,0,117,15,3,
            0,121,2,123,0,1,2,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,0,1,2,3,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,27,28,29,30,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,57,58,59,60,61,62,63,64,
            65,66,67,68,69,70,0,1,2,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,0,1,2,
            3,4,5,6,7,8,9,10,11,12,
            13,14,15,16,17,18,19,20,21,22,
            23,24,25,26,27,28,29,30,31,32,
            33,34,35,36,37,38,39,40,41,42,
            43,44,45,46,47,48,49,50,51,52,
            53,54,55,56,57,58,59,60,61,62,
            63,64,65,66,67,68,69,70,0,1,
            2,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,21,
            22,23,24,25,26,27,28,29,30,31,
            32,33,34,35,36,37,38,39,40,41,
            42,43,44,45,46,47,48,49,50,51,
            52,53,54,55,56,57,58,59,60,61,
            62,63,64,65,66,67,68,69,70,0,
            1,2,3,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            21,22,23,24,25,26,27,28,29,30,
            31,32,33,34,35,36,37,38,39,40,
            41,42,43,44,45,46,47,48,49,50,
            51,52,53,54,55,56,57,58,59,60,
            61,62,63,64,65,66,67,68,69,70,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,0,1,2,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,27,28,
            29,30,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,0,1,2,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            28,29,30,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,0,1,2,3,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,21,22,23,24,25,26,
            27,28,29,30,31,32,33,34,35,36,
            37,38,39,40,41,42,43,44,45,46,
            47,48,49,50,51,52,53,54,55,56,
            57,58,59,60,61,62,63,64,65,66,
            67,68,69,70,0,1,2,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,0,1,2,3,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,27,28,29,30,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,57,58,59,60,61,62,63,64,
            65,66,67,68,69,70,0,1,2,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,0,1,2,
            3,4,5,6,7,8,9,10,11,12,
            13,14,15,16,17,18,19,20,21,22,
            23,24,25,26,27,28,29,30,31,32,
            33,34,35,36,37,38,39,40,41,42,
            43,44,45,46,47,48,49,50,51,52,
            53,54,55,56,57,58,59,60,61,62,
            63,64,65,66,67,68,69,70,0,1,
            2,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,21,
            22,23,24,25,26,27,28,29,30,31,
            32,33,34,35,36,37,38,39,40,41,
            42,43,44,45,46,47,48,49,50,51,
            52,53,54,55,56,57,58,59,60,61,
            62,63,64,65,66,67,68,69,70,0,
            1,2,3,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            21,22,23,24,25,26,27,28,29,30,
            31,32,33,34,35,36,37,38,39,40,
            41,42,43,44,45,46,47,48,49,50,
            51,52,53,54,55,56,57,58,59,60,
            61,62,63,64,65,66,67,68,69,70,
            0,1,2,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,0,1,2,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,27,28,
            29,30,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,0,1,2,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            28,29,30,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,0,1,2,3,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,21,22,23,24,25,26,
            27,28,29,30,31,32,33,34,35,36,
            37,38,39,40,41,42,43,44,45,46,
            47,48,49,50,51,52,53,54,55,56,
            57,58,59,60,61,62,63,64,65,66,
            67,68,69,70,0,1,2,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,0,1,0,3,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,27,28,29,30,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,57,58,59,60,61,62,63,64,
            65,66,67,68,69,70,0,1,0,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,30,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,0,0,0,71,
            3,73,0,75,0,0,0,79,3,4,
            0,1,86,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            75,0,0,1,0,1,90,91,84,93,
            94,0,1,0,0,1,86,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,72,82,0,75,0,
            0,0,5,82,0,1,0,1,97,98,
            16,17,18,19,0,1,0,0,1,95,
            3,4,5,6,7,8,9,10,11,12,
            13,14,15,16,17,18,19,20,21,22,
            23,24,25,26,27,28,29,30,31,32,
            33,34,35,36,37,38,39,40,41,42,
            43,44,45,46,47,48,49,50,51,52,
            53,54,55,56,57,58,59,60,61,62,
            63,64,65,66,67,68,69,0,82,0,
            1,77,76,96,0,0,0,3,3,83,
            99,0,1,16,17,18,19,108,0,109,
            0,1,95,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            0,1,0,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            30,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,0,
            0,2,70,71,0,0,2,0,3,0,
            78,2,5,0,0,1,86,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,79,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,70,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,0,1,0,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,30,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,0,0,1,3,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,21,22,23,24,25,26,
            0,28,29,30,31,32,33,0,102,2,
            37,38,39,40,41,42,43,44,45,46,
            47,48,49,50,51,0,0,54,0,3,
            57,58,59,60,61,62,63,0,0,0,
            15,3,3,70,6,7,8,9,10,11,
            12,13,14,16,17,18,19,32,0,21,
            22,23,24,25,0,0,1,0,0,31,
            0,33,2,0,74,37,38,39,40,41,
            42,43,44,45,46,47,48,49,50,51,
            0,0,28,29,30,28,29,30,0,71,
            127,128,129,130,131,132,0,0,1,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,0,28,29,30,31,32,33,
            72,71,77,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,0,0,
            54,70,4,57,58,59,60,61,62,63,
            0,1,2,3,4,5,70,79,120,88,
            0,1,75,110,26,15,16,17,18,19,
            20,0,0,0,96,4,26,106,28,29,
            30,0,32,70,3,4,0,6,7,8,
            9,10,11,12,13,14,126,26,0,0,
            27,2,21,22,23,24,25,0,1,0,
            71,0,1,27,5,34,35,36,105,0,
            70,71,72,73,85,0,76,0,78,20,
            80,81,0,83,15,85,4,87,88,89,
            90,91,92,93,94,72,0,0,0,77,
            100,4,102,103,104,105,106,107,0,27,
            0,3,0,31,6,7,8,9,10,11,
            12,13,14,26,0,77,0,15,2,21,
            22,23,24,25,52,53,0,55,56,80,
            0,72,34,35,36,0,0,70,3,101,
            4,6,7,8,9,10,11,12,13,14,
            0,0,0,0,2,88,21,22,23,24,
            25,73,0,27,0,0,0,31,0,34,
            35,36,0,85,72,3,0,77,6,7,
            8,9,10,11,12,13,14,71,52,53,
            0,55,56,0,0,5,0,71,5,5,
            0,71,0,0,0,33,0,0,78,0,
            20,0,0,20,20,89,0,0,0,0,
            0,0,108,71,0,72,76,76,0,0,
            1,0,1,83,83,71,71,73,73,77,
            72,75,0,1,0,1,0,1,72,0,
            1,0,1,0,1,0,1,0,1,0,
            1,0,1,0,1,0,1,0,72,0,
            80,0,1,80,80,0,74,74,74,0,
            1,75,82,74,0,74,74,0,1,0,
            74,74,71,75,0,0,0,0,79,71,
            0,77,0,3,0,3,0,0,0,0,
            0,0,5,2,107,0,0,0,1,0,
            1,0,1,0,1,0,1,0,1,0,
            1,0,1,0,1,0,1,0,1,0,
            1,0,1,76,124,0,1,0,1,0,
            75,0,1,0,1,0,87,0,0,0,
            5,72,3,0,0,0,3,2,71,5,
            0,87,2,0,0,2,2,0,84,84,
            71,0,78,2,0,89,78,71,78,0,
            0,2,2,0,0,2,2,0,92,2,
            0,0,2,2,0,0,2,2,0,0,
            2,2,0,0,2,2,0,0,2,2,
            0,0,2,0,1,0,1,0,1,0,
            1,0,75,118,76,0,0,0,0,2,
            0,3,2,0,0,2,2,0,99,2,
            0,0,2,76,0,0,2,2,0,0,
            2,2,0,0,2,81,0,0,2,2,
            0,0,2,2,0,0,2,0,0,0,
            3,0,0,0,2,2,0,0,0,0,
            0,2,0,0,0,0,0,2,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            84,0,0,0,0,0,0,0,0,0,
            79,0,0,0,71,0,0,116,0,0,
            0,0,0,0,113,0,0,0,0,0,
            0,0,0,0,119,0,0,0,0,73,
            0,73,81,73,0,73,0,0,81,0,
            72,0,73,0,0,100,0,0,0,0,
            0,0,103,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,104,0,
            122,0,0,0,0,0,0,114,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,125,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0
        };
    };
    public final static char termCheck[] = TermCheck.termCheck;
    public final int termCheck(int index) { return termCheck[index]; }

    public interface TermAction {
        public final static char termAction[] = {0,
            336,3139,5359,1455,5295,5276,5446,5444,5445,5447,
            5448,5449,5450,5451,5452,4918,5241,5240,5239,5238,
            5245,1652,1649,1602,1504,1503,5242,5489,5237,5236,
            5235,1405,5243,5442,1356,1454,1406,5373,5374,5360,
            5361,5362,5363,5364,5365,5366,5367,5368,5369,5370,
            5371,5372,5486,5488,4890,5490,5491,5001,4997,5066,
            5289,5293,5292,5166,1658,2846,5493,5661,5662,2058,
            5359,37,5359,965,866,5359,5446,5444,5445,5447,
            5448,5449,5450,5451,5452,5359,5107,4763,4728,2810,
            1976,5466,5467,5468,5469,5470,5359,5359,1111,1747,
            768,3271,5489,347,1014,915,916,5359,5112,5359,
            5359,3183,592,1661,1662,3227,5359,3315,5707,5453,
            5359,3359,1827,1826,5359,3139,201,1455,5295,5276,
            5446,5444,5445,5447,5448,5449,5450,5451,5452,4918,
            5241,5240,5239,5238,5245,1652,1649,1602,1504,1503,
            5242,5489,5237,5236,5235,1405,5243,5442,1356,1454,
            1406,5373,5374,5360,5361,5362,5363,5364,5365,5366,
            5367,5368,5369,5370,5371,5372,5486,5488,4890,5490,
            5491,5001,4997,5066,5289,5293,5292,5166,1658,2846,
            5493,5661,5662,2058,5618,5359,3139,201,1455,5295,
            5276,5446,5444,5445,5447,5448,5449,5450,5451,5452,
            4918,5241,5240,5239,5238,5245,1652,1649,1602,1504,
            1503,5242,5489,5237,5236,5235,1405,5243,5442,1356,
            1454,1406,5373,5374,5360,5361,5362,5363,5364,5365,
            5366,5367,5368,5369,5370,5371,5372,5486,5488,4890,
            5490,5491,5001,4997,5066,5289,5293,5292,5166,1658,
            2846,5493,5661,5662,2058,5618,5359,3139,201,1455,
            5295,5276,5446,5444,5445,5447,5448,5449,5450,5451,
            5452,4918,5241,5240,5239,5238,5245,1652,1649,1602,
            1504,1503,5242,5489,5237,5236,5235,1405,5243,5442,
            1356,1454,1406,5373,5374,5360,5361,5362,5363,5364,
            5365,5366,5367,5368,5369,5370,5371,5372,5486,5488,
            4890,5490,5491,5001,4997,5066,5289,5293,5292,5166,
            1658,2846,5493,5661,5662,2058,5618,5359,3139,201,
            1455,5295,5276,5446,5444,5445,5447,5448,5449,5450,
            5451,5452,4918,5241,5240,5239,5238,5245,1652,1649,
            1602,1504,1503,5242,5489,5237,5236,5235,1405,5243,
            5442,1356,1454,1406,5373,5374,5360,5361,5362,5363,
            5364,5365,5366,5367,5368,5369,5370,5371,5372,5486,
            5488,4890,5490,5491,5001,4997,5066,5289,5293,5292,
            5166,1658,2846,5493,5661,5662,2058,5618,5359,3139,
            201,1455,5295,5276,5446,5444,5445,5447,5448,5449,
            5450,5451,5452,4918,5241,5240,5239,5238,5245,1652,
            1649,1602,1504,1503,5242,5489,5237,5236,5235,1405,
            5243,5442,1356,1454,1406,5373,5374,5360,5361,5362,
            5363,5364,5365,5366,5367,5368,5369,5370,5371,5372,
            5486,5488,4890,5490,5491,5001,4997,5066,5289,5293,
            5292,5166,1658,2846,5493,5661,5662,2058,5618,5359,
            3139,201,1455,5295,5276,5446,5444,5445,5447,5448,
            5449,5450,5451,5452,4918,5241,5240,5239,5238,5245,
            1652,1649,1602,1504,1503,5242,5489,5237,5236,5235,
            1405,5243,5442,1356,1454,1406,5373,5374,5360,5361,
            5362,5363,5364,5365,5366,5367,5368,5369,5370,5371,
            5372,5486,5488,4890,5490,5491,5001,4997,5066,5289,
            5293,5292,5166,1658,2846,5493,5661,5662,2058,5618,
            5359,3139,201,1455,5295,5276,5446,5444,5445,5447,
            5448,5449,5450,5451,5452,4918,5241,5240,5239,5238,
            5245,1652,1649,1602,1504,1503,5242,5489,5237,5236,
            5235,1405,5243,5442,1356,1454,1406,5373,5374,5360,
            5361,5362,5363,5364,5365,5366,5367,5368,5369,5370,
            5371,5372,5486,5488,4890,5490,5491,5001,4997,5066,
            5289,5293,5292,5166,1658,2846,5493,5661,5662,2058,
            5618,5359,3139,201,1455,5295,5276,5446,5444,5445,
            5447,5448,5449,5450,5451,5452,4918,5241,5240,5239,
            5238,5245,1652,1649,1602,1504,1503,5242,5489,5237,
            5236,5235,1405,5243,5442,1356,1454,1406,5373,5374,
            5360,5361,5362,5363,5364,5365,5366,5367,5368,5369,
            5370,5371,5372,5486,5488,4890,5490,5491,5001,4997,
            5066,5289,5293,5292,5166,1658,2846,5493,5661,5662,
            2058,5618,5359,3139,201,1455,5295,5276,5446,5444,
            5445,5447,5448,5449,5450,5451,5452,4918,5241,5240,
            5239,5238,5245,1652,1649,1602,1504,1503,5242,5489,
            5237,5236,5235,1405,5243,5442,1356,1454,1406,5373,
            5374,5360,5361,5362,5363,5364,5365,5366,5367,5368,
            5369,5370,5371,5372,5486,5488,4890,5490,5491,5001,
            4997,5066,5289,5293,5292,5166,1658,2846,5493,5661,
            5662,2058,5618,5359,3139,201,1455,5295,5276,5446,
            5444,5445,5447,5448,5449,5450,5451,5452,4918,5241,
            5240,5239,5238,5245,1652,1649,1602,1504,1503,5242,
            5489,5237,5236,5235,1405,5243,5442,1356,1454,1406,
            5373,5374,5360,5361,5362,5363,5364,5365,5366,5367,
            5368,5369,5370,5371,5372,5486,5488,4890,5490,5491,
            5001,4997,5066,5289,5293,5292,5166,1658,2846,5493,
            5661,5662,2058,5618,5359,3139,201,1455,5295,5276,
            5446,5444,5445,5447,5448,5449,5450,5451,5452,4918,
            5241,5240,5239,5238,5245,1652,1649,1602,1504,1503,
            5242,5489,5237,5236,5235,1405,5243,5442,1356,1454,
            1406,5373,5374,5360,5361,5362,5363,5364,5365,5366,
            5367,5368,5369,5370,5371,5372,5486,5488,4890,5490,
            5491,5001,4997,5066,5289,5293,5292,5166,1658,2846,
            5493,5661,5662,2058,5618,5359,3139,201,1455,5295,
            5276,5446,5444,5445,5447,5448,5449,5450,5451,5452,
            4918,5241,5240,5239,5238,5245,1652,1649,1602,1504,
            1503,5242,5489,5237,5236,5235,1405,5243,5442,1356,
            1454,1406,5373,5374,5360,5361,5362,5363,5364,5365,
            5366,5367,5368,5369,5370,5371,5372,5486,5488,4890,
            5490,5491,5001,4997,5066,5289,5293,5292,5166,1658,
            2846,5493,5661,5662,2058,5618,5359,3139,201,1455,
            5295,5276,5446,5444,5445,5447,5448,5449,5450,5451,
            5452,4918,5241,5240,5239,5238,5245,1652,1649,1602,
            1504,1503,5242,5489,5237,5236,5235,1405,5243,5442,
            1356,1454,1406,5373,5374,5360,5361,5362,5363,5364,
            5365,5366,5367,5368,5369,5370,5371,5372,5486,5488,
            4890,5490,5491,5001,4997,5066,5289,5293,5292,5166,
            1658,2846,5493,5661,5662,2058,5618,5359,3139,201,
            1455,5295,5276,5446,5444,5445,5447,5448,5449,5450,
            5451,5452,4918,5241,5240,5239,5238,5245,1652,1649,
            1602,1504,1503,5242,5489,5237,5236,5235,1405,5243,
            5442,1356,1454,1406,5373,5374,5360,5361,5362,5363,
            5364,5365,5366,5367,5368,5369,5370,5371,5372,5486,
            5488,4890,5490,5491,5001,4997,5066,5289,5293,5292,
            5166,1658,2846,5493,5661,5662,2058,5618,5359,3139,
            201,1455,5295,5276,5446,5444,5445,5447,5448,5449,
            5450,5451,5452,4918,5241,5240,5239,5238,5245,1652,
            1649,1602,1504,1503,5242,5489,5237,5236,5235,1405,
            5243,5442,1356,1454,1406,5373,5374,5360,5361,5362,
            5363,5364,5365,5366,5367,5368,5369,5370,5371,5372,
            5486,5488,4890,5490,5491,5001,4997,5066,5289,5293,
            5292,5166,1658,2846,5493,5661,5662,2058,5618,5359,
            3139,201,1455,5295,5276,5446,5444,5445,5447,5448,
            5449,5450,5451,5452,4918,5241,5240,5239,5238,5245,
            1652,1649,1602,1504,1503,5242,5489,5237,5236,5235,
            1405,5243,5442,1356,1454,1406,5373,5374,5360,5361,
            5362,5363,5364,5365,5366,5367,5368,5369,5370,5371,
            5372,5486,5488,4890,5490,5491,5001,4997,5066,5289,
            5293,5292,5166,1658,2846,5493,5661,5662,2058,5618,
            5359,3139,201,1455,5295,5276,5446,5444,5445,5447,
            5448,5449,5450,5451,5452,4918,5241,5240,5239,5238,
            5245,1652,1649,1602,1504,1503,5242,5489,5237,5236,
            5235,1405,5243,5442,1356,1454,1406,5373,5374,5360,
            5361,5362,5363,5364,5365,5366,5367,5368,5369,5370,
            5371,5372,5486,5488,4890,5490,5491,5001,4997,5066,
            5289,5293,5292,5166,1658,2846,5493,5661,5662,2058,
            5618,5359,3139,201,1455,5295,5276,5446,5444,5445,
            5447,5448,5449,5450,5451,5452,4918,5241,5240,5239,
            5238,5245,1652,1649,1602,1504,1503,5242,5489,5237,
            5236,5235,1405,5243,5442,1356,1454,1406,5373,5374,
            5360,5361,5362,5363,5364,5365,5366,5367,5368,5369,
            5370,5371,5372,5486,5488,4890,5490,5491,5001,4997,
            5066,5289,5293,5292,5166,1658,2846,5493,5661,5662,
            2058,5618,5359,3139,201,1455,5295,5276,5446,5444,
            5445,5447,5448,5449,5450,5451,5452,4918,5241,5240,
            5239,5238,5245,1652,1649,1602,1504,1503,5242,5489,
            5237,5236,5235,1405,5243,5442,1356,1454,1406,5373,
            5374,5360,5361,5362,5363,5364,5365,5366,5367,5368,
            5369,5370,5371,5372,5486,5488,4890,5490,5491,5001,
            4997,5066,5289,5293,5292,5166,1658,2846,5493,5661,
            5662,2058,5618,5359,3139,201,1455,5295,5276,5446,
            5444,5445,5447,5448,5449,5450,5451,5452,4918,5241,
            5240,5239,5238,5245,1652,1649,1602,1504,1503,5242,
            5489,5237,5236,5235,1405,5243,5442,1356,1454,1406,
            5373,5374,5360,5361,5362,5363,5364,5365,5366,5367,
            5368,5369,5370,5371,5372,5486,5488,4890,5490,5491,
            5001,4997,5066,5289,5293,5292,5166,1658,2846,5493,
            5661,5662,2058,5618,5359,3139,201,1455,5295,5276,
            5446,5444,5445,5447,5448,5449,5450,5451,5452,4918,
            5241,5240,5239,5238,5245,1652,1649,1602,1504,1503,
            5242,5489,5237,5236,5235,1405,5243,5442,1356,1454,
            1406,5373,5374,5360,5361,5362,5363,5364,5365,5366,
            5367,5368,5369,5370,5371,5372,5486,5488,4890,5490,
            5491,5001,4997,5066,5289,5293,5292,5166,1658,2846,
            5493,5661,5662,2058,5618,5359,3139,5359,1455,5295,
            5276,5446,5444,5445,5447,5448,5449,5450,5451,5452,
            4918,5241,5240,5239,5238,5245,1652,1649,1602,1504,
            1503,5242,5489,5237,5236,5235,1405,5243,5442,1356,
            1454,1406,5373,5374,5360,5361,5362,5363,5364,5365,
            5366,5367,5368,5369,5370,5371,5372,5486,5488,4890,
            5490,5491,5001,4997,5066,5289,5293,5292,5166,1658,
            2846,5493,5661,5662,2058,5618,112,3139,84,1455,
            5295,5276,5446,5444,5445,5447,5448,5449,5450,5451,
            5452,4946,5241,5240,5239,5238,5245,1652,1649,1602,
            1504,1503,5242,5489,5237,5236,5235,1405,5243,5442,
            1356,1454,1406,5373,5374,5360,5361,5362,5363,5364,
            5365,5366,5367,5368,5369,5370,5371,5372,5486,5488,
            4890,5490,5491,5001,4997,5066,5289,5293,5292,5166,
            1658,2846,5493,5661,5662,2058,66,5359,5359,157,
            818,157,5359,94,5359,326,5359,5197,1661,1662,
            5359,3139,3579,1455,5295,5276,5446,5444,5445,5447,
            5448,5449,5450,5451,5452,4946,5241,5240,5239,5238,
            5245,1652,1649,1602,1504,1503,5242,5489,5237,5236,
            5235,1405,5243,5442,1356,1454,1406,5373,5374,5360,
            5361,5362,5363,5364,5365,5366,5367,5368,5369,5370,
            5371,5372,5486,5488,4890,5490,5491,5001,4997,5066,
            5289,5293,5292,5166,1658,2846,5493,5661,5662,2058,
            1744,310,5359,5123,128,199,4974,5073,5679,1722,
            1659,133,22,5359,212,3139,3579,1455,5295,5276,
            5446,5444,5445,5447,5448,5449,5450,5451,5452,4918,
            5241,5240,5239,5238,5245,1652,1649,1602,1504,1503,
            5242,5489,5237,5236,5235,1405,5243,5442,1356,1454,
            1406,5373,5374,5360,5361,5362,5363,5364,5365,5366,
            5367,5368,5369,5370,5371,5372,5486,5488,4890,5490,
            5491,5001,4997,5066,5289,5293,5292,5166,1658,2846,
            5493,5661,5662,2058,260,2233,5559,221,567,5359,
            314,5359,3447,22,5359,5231,199,21,1747,768,
            4763,4728,2810,1976,5359,4983,70,5359,3139,5030,
            1455,5295,5276,5446,5444,5445,5447,5448,5449,5450,
            5451,5452,4918,5241,5240,5239,5238,5245,1652,1649,
            1602,1504,1503,5242,5489,5237,5236,5235,1405,5243,
            5442,1356,1454,1406,5373,5374,5360,5361,5362,5363,
            5364,5365,5366,5367,5368,5369,5370,5371,5372,5486,
            5488,4890,5490,5491,5001,4997,5066,5289,5293,5292,
            5166,1658,2846,5493,5661,5662,2058,41,9106,5359,
            674,4988,294,3403,5359,167,5359,5693,1819,5654,
            5688,5359,723,4763,4728,2810,1976,5358,5359,1731,
            5359,3139,5030,1455,5295,5276,5446,5444,5445,5447,
            5448,5449,5450,5451,5452,4918,5241,5240,5239,5238,
            5245,1652,1649,1602,1504,1503,5242,5489,5237,5236,
            5235,1405,5243,5442,1356,1454,1406,5373,5374,5360,
            5361,5362,5363,5364,5365,5366,5367,5368,5369,5370,
            5371,5372,5486,5488,4890,5490,5491,5001,4997,5066,
            5289,5293,5292,5166,1658,2846,5493,5661,5662,2058,
            5359,3139,5359,1455,5295,5276,5446,5444,5445,5447,
            5448,5449,5450,5451,5452,4918,5241,5240,5239,5238,
            5245,1652,1649,1602,1504,1503,5242,5489,5237,5236,
            5235,1405,5243,5442,1356,1454,1406,5373,5374,5360,
            5361,5362,5363,5364,5365,5366,5367,5368,5369,5370,
            5371,5372,5486,5488,4890,5490,5491,5001,4997,5066,
            5289,5293,5292,5166,1658,2846,5493,5661,5662,5359,
            5359,5623,5618,566,5359,5359,5524,157,1829,5359,
            274,5525,3535,5359,5359,3139,3755,3092,5295,5276,
            5446,5444,5445,5447,5448,5449,5450,5451,5452,4918,
            5241,5240,5239,5238,5245,1652,1649,1602,1504,1503,
            5242,5489,5237,5236,5235,1405,5243,5442,1356,1454,
            1406,5373,5374,5360,5361,5362,5363,5364,5365,5366,
            5367,5368,5369,5370,5371,5372,5486,5488,4890,5490,
            5491,5001,4997,5066,5289,5293,5292,5166,1658,2846,
            5493,5661,5662,2058,53,478,5197,478,478,478,
            478,478,478,478,478,478,478,478,478,478,
            478,478,478,478,478,478,478,478,478,478,
            478,478,478,478,478,478,478,478,478,478,
            478,478,478,478,478,478,478,478,478,478,
            478,478,478,478,478,478,478,478,478,478,
            478,478,478,478,478,478,478,478,478,478,
            478,478,478,478,254,2127,5359,2127,2127,2127,
            2127,2127,2127,2127,2127,2127,2127,2127,2127,2127,
            2127,2127,2127,2127,2127,2127,2127,2127,2127,2127,
            2127,2127,2127,2127,2127,2127,2127,2127,2127,2127,
            2127,2127,2127,2127,2127,2127,2127,2127,2127,2127,
            2127,2127,2127,2127,2127,2127,2127,2127,2127,2127,
            2127,2127,2127,2127,2127,2127,2127,2127,2127,2127,
            2127,2127,2127,2127,253,2185,5618,2185,2185,2185,
            2185,2185,2185,2185,2185,2185,2185,2185,2185,2185,
            2185,2185,2185,2185,2185,2185,2185,2185,2185,2185,
            2185,2185,2185,2185,2185,2185,2185,2185,2185,2185,
            2185,2185,2185,2185,2185,2185,2185,2185,2185,2185,
            2185,2185,2185,2185,2185,2185,2185,2185,2185,2185,
            2185,2185,2185,2185,2185,2185,2185,2185,2185,2185,
            2185,2185,2185,2185,252,2243,5359,2243,2243,2243,
            2243,2243,2243,2243,2243,2243,2243,2243,2243,2243,
            2243,2243,2243,2243,2243,2243,2243,2243,2243,2243,
            2243,2243,2243,2243,2243,2243,2243,2243,2243,2243,
            2243,2243,2243,2243,2243,2243,2243,2243,2243,2243,
            2243,2243,2243,2243,2243,2243,2243,2243,2243,2243,
            2243,2243,2243,2243,2243,2243,2243,2243,2243,2243,
            2243,2243,2243,2243,251,2301,5359,2301,2301,2301,
            2301,2301,2301,2301,2301,2301,2301,2301,2301,2301,
            2301,2301,2301,2301,2301,2301,2301,2301,2301,2301,
            2301,2301,2301,2301,2301,2301,2301,2301,2301,2301,
            2301,2301,2301,2301,2301,2301,2301,2301,2301,2301,
            2301,2301,2301,2301,2301,2301,2301,2301,2301,2301,
            2301,2301,2301,2301,2301,2301,2301,2301,2301,2301,
            2301,2301,2301,2301,250,2359,5359,2359,2359,2359,
            2359,2359,2359,2359,2359,2359,2359,2359,2359,2359,
            2359,2359,2359,2359,2359,2359,2359,2359,2359,2359,
            2359,2359,2359,2359,2359,2359,2359,2359,2359,2359,
            2359,2359,2359,2359,2359,2359,2359,2359,2359,2359,
            2359,2359,2359,2359,2359,2359,2359,2359,2359,2359,
            2359,2359,2359,2359,2359,2359,2359,2359,2359,2359,
            2359,2359,2359,2359,249,2417,5359,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,2417,2417,2417,2417,2417,2417,
            2417,2417,2417,2417,248,2475,5359,2475,2475,2475,
            2475,2475,2475,2475,2475,2475,2475,2475,2475,2475,
            2475,2475,2475,2475,2475,2475,2475,2475,2475,2475,
            2475,2475,2475,2475,2475,2475,2475,2475,2475,2475,
            2475,2475,2475,2475,2475,2475,2475,2475,2475,2475,
            2475,2475,2475,2475,2475,2475,2475,2475,2475,2475,
            2475,2475,2475,2475,2475,2475,2475,2475,2475,2475,
            2475,2475,2475,2475,247,2533,5359,2533,2533,2533,
            2533,2533,2533,2533,2533,2533,2533,2533,2533,2533,
            2533,2533,2533,2533,2533,2533,2533,2533,2533,2533,
            2533,2533,2533,2533,2533,2533,2533,2533,2533,2533,
            2533,2533,2533,2533,2533,2533,2533,2533,2533,2533,
            2533,2533,2533,2533,2533,2533,2533,2533,2533,2533,
            2533,2533,2533,2533,2533,2533,2533,2533,2533,2533,
            2533,2533,2533,2533,246,2591,5359,2591,2591,2591,
            2591,2591,2591,2591,2591,2591,2591,2591,2591,2591,
            2591,2591,2591,2591,2591,2591,2591,2591,2591,2591,
            2591,2591,2591,2591,2591,2591,2591,2591,2591,2591,
            2591,2591,2591,2591,2591,2591,2591,2591,2591,2591,
            2591,2591,2591,2591,2591,2591,2591,2591,2591,2591,
            2591,2591,2591,2591,2591,2591,2591,2591,2591,2591,
            2591,2591,2591,2591,245,2649,5359,2649,2649,2649,
            2649,2649,2649,2649,2649,2649,2649,2649,2649,2649,
            2649,2649,2649,2649,2649,2649,2649,2649,2649,2649,
            2649,2649,2649,2649,2649,2649,2649,2649,2649,2649,
            2649,2649,2649,2649,2649,2649,2649,2649,2649,2649,
            2649,2649,2649,2649,2649,2649,2649,2649,2649,2649,
            2649,2649,2649,2649,2649,2649,2649,2649,2649,2649,
            2649,2649,2649,2649,244,2707,5359,2707,2707,2707,
            2707,2707,2707,2707,2707,2707,2707,2707,2707,2707,
            2707,2707,2707,2707,2707,2707,2707,2707,2707,2707,
            2707,2707,2707,2707,2707,2707,2707,2707,2707,2707,
            2707,2707,2707,2707,2707,2707,2707,2707,2707,2707,
            2707,2707,2707,2707,2707,2707,2707,2707,2707,2707,
            2707,2707,2707,2707,2707,2707,2707,2707,2707,2707,
            2707,2707,2707,2707,5359,3139,5359,1455,5295,5276,
            5446,5444,5445,5447,5448,5449,5450,5451,5452,4918,
            5241,5240,5239,5238,5245,1652,1649,1602,1504,1503,
            5242,5489,5237,5236,5235,1405,5243,5442,1356,1454,
            1406,5373,5374,5360,5361,5362,5363,5364,5365,5366,
            5367,5368,5369,5370,5371,5372,5486,5488,4890,5490,
            5491,5001,4997,5066,5289,5293,5292,5166,1658,2846,
            5493,5661,5662,5359,5359,5207,5443,5303,5276,5446,
            5444,5445,5447,5448,5449,5450,5451,5452,5302,5241,
            5240,5239,5238,5245,5375,5376,5377,5378,5379,5242,
            5359,5237,5236,5235,5381,5243,5442,5359,4019,5438,
            5373,5374,2528,2588,2587,2586,2584,2585,2583,2582,
            2581,2580,2578,2530,5372,53,5359,5301,5359,1819,
            5001,4997,5066,5289,5293,5292,5166,39,5359,361,
            8000,5443,5721,5618,5446,5444,5445,5447,5448,5449,
            5450,5451,5452,4763,4728,2810,1976,4798,5359,5375,
            5376,5377,5378,5379,25,5359,5003,27,312,5381,
            5359,5442,1112,317,522,5373,5374,5360,5361,5362,
            5363,5364,5365,5366,5367,5368,5369,5370,5371,5372,
            305,5359,4578,4539,4500,4578,4539,4500,94,5177,
            5639,5640,5641,5642,5643,5644,5359,105,1556,5443,
            5303,5276,5446,5444,5445,5447,5448,5449,5450,5451,
            5452,5302,5241,5240,5239,5238,5245,5375,5376,5377,
            5378,5379,5242,5359,5237,5236,5235,5381,5243,5442,
            1748,1668,5102,5373,5374,5360,5361,5362,5363,5364,
            5365,5366,5367,5368,5369,5370,5371,5372,54,5359,
            5301,5618,4860,5001,4997,5066,5289,5293,5292,5166,
            5359,21,5559,5559,5559,5559,5618,5118,5727,5586,
            5359,5212,95,669,4830,5559,5559,5559,5559,5559,
            5559,58,5359,5359,3095,4860,5559,2765,5559,5559,
            5559,5359,5559,5618,965,1258,124,5446,5444,5445,
            5447,5448,5449,5450,5451,5452,662,4830,353,5359,
            5621,5626,5466,5467,5468,5469,5470,5359,5217,29,
            2241,5359,1822,5621,4691,1014,915,916,1931,345,
            5559,5559,5559,5559,2345,5359,5559,5359,5559,4654,
            5559,5559,275,5559,9614,5559,5487,5559,5559,5559,
            5559,5559,5559,5559,5559,1820,5359,56,5359,5133,
            5559,4860,5559,5559,5559,5559,5559,5559,5359,5489,
            5359,5453,345,5492,5446,5444,5445,5447,5448,5449,
            5450,5451,5452,4830,313,3931,5359,9614,1209,5466,
            5467,5468,5469,5470,5486,5488,5359,5490,5491,4617,
            5359,347,1014,915,916,5359,5359,5618,965,3887,
            5487,5446,5444,5445,5447,5448,5449,5450,5451,5452,
            138,135,5359,312,5716,5585,5466,5467,5468,5469,
            5470,4195,5359,5489,5359,5359,164,5492,5359,1014,
            915,916,5359,2589,347,5443,5359,5138,5446,5444,
            5445,5447,5448,5449,5450,5451,5452,5008,5486,5488,
            33,5490,5491,32,31,4691,5359,2122,4691,4691,
            199,5016,5359,5359,5359,5442,84,23,5485,20,
            4654,19,18,4654,4654,2891,17,16,5359,157,
            5359,168,306,2936,5359,1750,294,294,206,5359,
            772,5359,821,5654,5654,2241,2647,4151,2981,5143,
            2124,567,5359,870,5359,919,5359,968,2232,5359,
            1017,5359,1066,5359,1115,5359,1164,5359,1213,5359,
            1262,5359,1311,5359,1360,5359,1409,5359,5031,5359,
            4617,5359,1458,4617,4617,358,5232,598,5015,80,
            1507,94,5559,111,5359,110,109,356,2012,5359,
            108,107,2241,585,5359,5359,5359,207,5197,2415,
            5359,5202,96,2702,5359,5453,117,5359,5359,113,
            5359,5359,3799,5432,4459,369,202,287,5233,286,
            1605,1,2531,5359,5308,12,8070,11,8140,10,
            8210,9,8280,8,8350,7,8420,5,8490,6,
            8560,4,8630,3623,3491,3,8700,2,8770,5359,
            567,5359,1673,5359,1753,158,2698,97,5359,5359,
            3843,5147,4999,5359,5359,5359,2183,5554,2473,3535,
            5359,2699,5617,5359,5359,5616,5615,5359,5682,5680,
            2060,5359,5465,5555,5359,3667,5624,2936,5627,5359,
            5359,5553,5552,5359,5359,5551,5550,5359,3711,5549,
            5359,5359,5548,5547,5359,5359,5546,5544,5359,5359,
            5543,5542,5359,5359,5541,5540,5359,5359,5539,5545,
            5359,5359,5538,5359,1833,5359,1882,198,723,197,
            1507,364,567,3975,4063,371,5359,5359,297,5433,
            5359,9615,5648,5359,5359,5647,5510,5359,5689,5509,
            5359,217,5508,2105,5359,5359,5507,5506,5359,5359,
            5505,5504,5359,213,5503,5659,5359,5359,5502,5501,
            5359,5359,5500,5570,5359,366,5569,5359,5359,5359,
            5724,5359,5359,5359,5537,5536,5359,5359,5359,5359,
            5359,5514,5359,5359,375,5359,5359,5515,345,297,
            5359,5359,5359,5359,5359,5359,5359,5359,5359,5359,
            5359,5359,5359,5359,5359,5359,5359,5359,5359,5359,
            5681,5359,5359,5359,5359,5359,5359,5359,5359,5359,
            5222,5359,5359,5359,3026,5359,5359,5719,5359,5359,
            5359,5359,5359,5359,5076,5359,5359,5359,5359,5359,
            5359,5359,5359,5359,2240,5359,5359,5359,5359,5655,
            5359,4327,5660,4371,5359,4415,5359,5359,5658,5359,
            5707,5359,5221,5359,5359,4239,5359,5359,5359,5359,
            5359,5359,4283,5359,5359,5359,5359,5359,5359,5359,
            5359,5359,5359,5359,5359,5359,5359,5359,5735,5359,
            5732,5359,5359,5359,5359,5359,5359,5722,5359,5359,
            5359,5359,5359,5359,5359,5359,5359,5359,5359,5359,
            5359,5733
        };
    };
    public final static char termAction[] = TermAction.termAction;
    public final int termAction(int index) { return termAction[index]; }

    public interface Asb {
        public final static char asb[] = {0,
            550,421,78,394,392,395,394,73,393,392,
            396,395,651,75,310,310,152,651,155,78,
            418,418,318,315,315,318,79,641,419,419,
            372,373,315,373,373,444,479,319,319,158,
            171,319,319,651,309,479,309,430,372,430,
            373,373,584,373,373,665,176,568,310,373,
            430,178,373,444,373,480,444,651,585,585,
            584,85,543,543,543,543,543,543,543,543,
            543,543,543,543,543,543,543,543,543,543,
            543,180,180,182,269,269,180,180,224,268,
            268,268,268,268,269,269,174,319,273,271,
            277,279,284,280,290,287,166,444,444,399,
            479,309,651,584,584,584,584,584,410,567,
            373,309,430,309,373,312,312,412,444,1,
            319,319,319,319,319,319,319,319,319,319,
            319,319,319,319,319,319,319,319,319,4,
            651,319,4,558,226,620,84,100,482,641,
            641,423,584,584,584,584,584,584,584,584,
            584,584,584,584,584,584,584,584,584,373,
            651,568,426,425,546,432,309,432,584,310,
            309,176,373,176,444,313,312,651,85,651,
            584,85,84,373,373,373,665,84,84,84,
            84,84,84,84,84,84,84,84,84,84,
            84,565,434,584,6,415,415,84,565,565,
            169,653,84,225,444,479,271,543,543,543,
            269,269,271,270,541,438,438,269,319,269,
            269,269,269,269,269,269,269,269,269,269,
            319,319,584,277,277,280,280,280,287,284,
            284,284,260,427,85,309,651,406,651,441,
            567,178,309,584,651,169,661,444,444,444,
            444,444,443,444,444,444,444,444,444,444,
            444,444,444,444,444,444,444,584,584,5,
            651,444,584,67,444,84,85,423,319,319,
            226,226,423,651,584,651,541,584,584,584,
            584,584,584,584,584,584,584,584,321,321,
            446,584,584,584,479,448,553,407,584,309,
            584,176,85,444,584,84,84,584,444,450,
            444,403,453,265,444,403,444,444,444,444,
            444,444,444,444,444,444,444,478,479,444,
            220,220,651,408,309,309,657,659,662,446,
            444,444,584,266,651,584,651,584,651,85,
            373,322,584,309,406,584,446,266,266,444,
            266,668,308,584,584,584,309,444,670
        };
    };
    public final static char asb[] = Asb.asb;
    public final int asb(int index) { return asb[index]; }

    public interface Asr {
        public final static char asr[] = {0,
            70,105,0,78,69,64,39,40,41,42,
            43,44,45,46,47,48,49,50,51,37,
            38,21,22,23,24,25,7,8,6,9,
            10,11,12,13,14,33,3,35,36,66,
            34,61,62,60,5,20,32,26,16,17,
            18,19,28,29,30,63,59,57,58,65,
            1,67,68,15,54,86,31,52,4,53,
            55,56,27,0,27,72,0,109,110,97,
            98,72,0,2,64,35,36,66,52,53,
            27,55,56,34,65,1,67,68,69,70,
            7,8,6,9,10,11,12,13,14,33,
            61,62,60,5,20,32,26,16,17,18,
            19,28,29,30,63,59,57,58,15,54,
            31,39,40,41,42,43,44,45,46,47,
            48,49,50,51,37,38,21,22,23,24,
            25,4,3,0,75,72,0,15,78,73,
            85,89,3,72,75,2,71,96,5,0,
            3,79,96,75,0,84,0,99,0,74,
            0,32,4,26,16,17,5,18,19,20,
            2,78,76,81,90,73,71,85,91,92,
            93,94,83,80,87,102,103,104,105,106,
            88,28,29,30,107,89,3,70,27,15,
            72,100,0,82,75,32,15,4,26,16,
            17,18,19,20,76,81,90,91,92,93,
            94,83,80,100,87,102,103,104,105,106,
            88,28,29,30,107,3,72,70,1,2,
            78,71,89,5,85,73,0,74,1,82,
            76,83,93,94,90,91,4,26,32,16,
            17,18,19,5,20,80,28,29,30,2,
            78,81,73,71,85,92,100,87,102,103,
            105,106,88,89,3,70,107,104,15,72,
            0,71,89,0,4,3,75,77,1,0,
            2,69,15,54,1,67,68,65,31,61,
            62,60,5,20,32,26,16,17,18,19,
            28,29,30,63,59,57,58,55,56,27,
            53,52,66,33,39,40,41,42,43,44,
            45,46,47,48,49,50,51,37,38,64,
            95,4,7,8,6,9,10,11,12,13,
            14,34,21,22,23,24,25,3,36,35,
            0,72,108,109,110,98,97,0,2,85,
            89,79,71,73,0,118,119,120,0,124,
            0,89,79,5,78,71,0,72,98,97,
            108,0,76,0,75,1,15,72,101,77,
            0,87,0,78,71,92,0,70,1,0,
            102,0,75,2,0,81,0,116,0,71,
            85,0,73,75,32,15,4,26,16,17,
            5,18,19,20,1,76,90,91,82,93,
            94,83,80,28,29,30,107,79,2,71,
            0,40,41,42,44,43,45,46,47,48,
            49,50,39,131,132,127,128,129,130,51,
            37,38,21,22,23,24,25,31,7,8,
            6,9,10,11,12,13,14,33,3,61,
            62,60,5,20,32,4,26,16,17,18,
            19,28,29,30,63,59,57,58,15,54,
            70,0,1,82,0,15,72,3,0,108,
            126,0,15,100,72,113,0,31,52,4,
            53,27,55,56,78,0,72,84,99,114,
            116,118,119,120,122,125,123,121,117,101,
            115,111,112,69,64,35,36,66,52,4,
            53,27,55,56,34,61,62,60,5,20,
            32,26,16,17,18,19,28,29,30,63,
            59,57,58,65,1,67,68,15,54,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,37,38,21,22,23,24,25,31,
            7,8,6,9,10,11,12,13,14,33,
            3,0,78,70,71,0,122,0,103,0,
            106,70,88,0,2,3,0,114,0,125,
            0
        };
    };
    public final static char asr[] = Asr.asr;
    public final int asr(int index) { return asr[index]; }

    public interface Nasb {
        public final static char nasb[] = {0,
            135,124,33,27,33,25,27,101,124,33,
            29,25,78,124,124,124,57,124,124,33,
            33,33,124,49,49,124,33,123,21,21,
            129,77,49,129,77,124,124,124,124,124,
            124,124,124,124,39,124,39,124,51,124,
            77,77,74,77,77,47,124,1,124,51,
            124,124,77,124,77,124,124,68,74,74,
            74,82,125,125,125,125,125,125,125,125,
            125,125,125,125,125,125,125,125,125,125,
            125,124,124,124,125,124,124,124,124,124,
            124,124,124,124,125,125,124,124,8,55,
            124,124,124,124,124,124,124,124,124,124,
            124,39,78,74,74,74,74,74,124,147,
            77,39,124,39,77,35,124,124,124,87,
            124,124,124,124,124,124,124,124,124,124,
            124,124,124,124,124,124,124,124,124,74,
            155,124,74,139,124,122,74,150,117,123,
            123,124,110,110,11,11,103,103,103,61,
            61,61,61,89,96,96,96,74,74,77,
            69,1,80,124,127,124,39,124,74,124,
            39,124,77,124,124,124,124,69,82,143,
            74,82,74,77,77,77,78,74,74,74,
            74,74,74,74,74,74,74,74,74,74,
            74,124,124,74,74,124,124,74,124,124,
            124,87,74,124,124,124,55,125,125,125,
            125,125,55,125,87,124,124,124,124,124,
            124,124,124,124,124,124,124,124,124,124,
            124,124,74,124,124,124,124,124,124,124,
            124,124,124,124,74,39,124,59,124,124,
            147,124,39,74,69,124,87,124,124,124,
            124,124,124,124,124,124,124,124,124,124,
            124,124,124,124,124,124,124,74,74,74,
            142,124,74,18,124,74,82,124,124,124,
            124,124,124,157,42,69,87,73,73,73,
            73,73,73,73,73,73,73,73,74,74,
            124,74,74,74,124,124,137,145,74,39,
            74,124,82,124,74,74,74,71,124,124,
            124,124,124,124,124,124,124,124,124,124,
            124,124,124,124,124,124,124,124,124,124,
            37,37,124,124,39,39,124,124,87,124,
            124,124,74,124,143,74,69,74,69,82,
            77,74,74,39,59,74,124,124,124,124,
            124,124,133,74,74,74,39,124,124
        };
    };
    public final static char nasb[] = Nasb.nasb;
    public final int nasb(int index) { return nasb[index]; }

    public interface Nasr {
        public final static char nasr[] = {0,
            2,4,5,7,3,89,0,104,105,0,
            5,4,2,3,7,31,0,7,82,0,
            71,72,85,0,87,0,86,0,71,72,
            70,0,58,0,113,0,101,0,54,55,
            0,5,4,2,3,7,67,0,73,0,
            2,3,64,0,69,0,63,0,102,0,
            5,4,2,3,7,33,0,114,46,0,
            125,0,46,4,5,7,3,2,0,128,
            0,2,4,5,7,3,44,0,2,4,
            5,7,3,40,0,5,4,2,3,38,
            7,0,2,4,5,7,3,36,0,2,
            4,5,7,3,28,0,115,119,120,108,
            44,6,4,0,45,0,129,0,3,2,
            88,0,132,0,103,0,130,0,117,7,
            0,46,59,0,131,0,54,97,0,4,
            6,15,44,0,107,0,67,123,0
        };
    };
    public final static char nasr[] = Nasr.nasr;
    public final int nasr(int index) { return nasr[index]; }

    public interface TerminalIndex {
        public final static char terminalIndex[] = {0,
            11,12,223,3,7,145,146,147,148,149,
            151,152,153,154,2,5,6,8,9,10,
            120,121,122,123,124,4,38,105,106,107,
            117,1,93,150,218,219,114,115,125,126,
            127,128,129,130,131,132,133,134,135,136,
            144,39,40,108,112,113,137,138,139,140,
            141,142,143,37,101,155,220,221,110,229,
            19,228,18,13,21,15,73,14,20,33,
            16,25,32,68,22,41,75,104,111,17,
            23,24,26,27,28,30,67,69,70,74,
            77,89,90,91,102,103,109,222,65,66,
            71,72,76,78,79,80,81,82,83,84,
            85,86,87,88,92,35,204,205,206,207,
            208,209,29,31,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,34,94,95,
            96,97,98,99,100,116,118,119,156,157,
            158,159,160,161,162,163,164,165,166,167,
            168,169,170,171,172,173,174,175,176,177,
            178,179,180,181,182,183,184,185,186,187,
            188,189,190,191,192,193,194,195,196,197,
            198,199,200,201,202,203,210,211,212,213,
            214,215,216,217,224,225,226,227
        };
    };
    public final static char terminalIndex[] = TerminalIndex.terminalIndex;
    public final int terminalIndex(int index) { return terminalIndex[index]; }

    public interface NonterminalIndex {
        public final static char nonterminalIndex[] = {0,
            0,251,254,252,230,231,257,0,0,0,
            0,0,0,0,253,245,247,248,0,0,
            0,0,0,0,0,0,0,246,0,243,
            244,240,241,242,238,239,236,237,234,235,
            232,233,0,271,0,262,266,0,263,0,
            0,0,0,0,291,288,261,0,264,0,
            0,0,287,290,256,0,265,269,0,282,
            283,284,0,0,255,259,0,0,268,270,
            274,275,0,0,0,285,286,289,0,292,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,249,250,0,258,260,0,0,
            0,0,267,272,273,0,276,0,277,278,
            279,280,281,0,0,0,293,0,0,0,
            0,0,0
        };
    };
    public final static char nonterminalIndex[] = NonterminalIndex.nonterminalIndex;
    public final int nonterminalIndex(int index) { return nonterminalIndex[index]; }

    public interface ScopePrefix {
        public final static char scopePrefix[] = {
            1,29,358,51,74,201,201,13,21,120,
            386,456,366,39,69,147,152,157,184,184,
            234,239,248,253,258,263,268,273,278,283,
            288,293,298,303,308,313,318,323,328,333,
            338,184,60,184,184,104,110,114,134,138,
            343,347,401,405,409,413,417,421,425,429,
            433,437,441,445,449,462,90,244,351,392,
            126,376,81,376,176,453,167,167,176,176,
            176,176,176,176,46,97,142,162,162,466,
            466,474,474,482,482,482,482,142,142,502,
            502,502,97,162
        };
    };
    public final static char scopePrefix[] = ScopePrefix.scopePrefix;
    public final int scopePrefix(int index) { return scopePrefix[index]; }

    public interface ScopeSuffix {
        public final static char scopeSuffix[] = {
            11,37,108,58,58,179,218,19,27,108,
            108,108,372,44,58,108,108,108,179,218,
            108,108,108,108,108,108,108,108,108,108,
            108,108,108,108,108,108,108,108,108,108,
            108,193,65,208,224,108,108,118,118,108,
            108,108,108,108,108,108,108,108,108,108,
            108,108,108,118,118,108,94,173,355,94,
            130,372,85,380,179,108,170,173,181,189,
            220,196,212,228,48,94,144,164,94,468,
            471,476,479,484,487,490,493,496,499,504,
            507,510,99,396
        };
    };
    public final static char scopeSuffix[] = ScopeSuffix.scopeSuffix;
    public final int scopeSuffix(int index) { return scopeSuffix[index]; }

    public interface ScopeLhs {
        public final static char scopeLhs[] = {
            96,93,110,17,104,25,25,95,94,53,
            110,17,110,92,18,8,8,8,25,25,
            105,105,15,8,8,8,8,8,8,8,
            8,8,8,8,8,8,8,8,8,76,
            76,25,17,25,25,118,118,27,26,52,
            50,51,109,109,109,109,109,109,109,109,
            109,109,109,23,22,17,123,29,46,57,
            53,110,104,110,25,18,29,29,25,25,
            25,25,25,25,89,122,38,57,57,31,
            31,33,33,36,36,36,36,38,38,40,
            40,40,123,57
        };
    };
    public final static char scopeLhs[] = ScopeLhs.scopeLhs;
    public final int scopeLhs(int index) { return scopeLhs[index]; }

    public interface ScopeLa {
        public final static char scopeLa[] = {
            125,114,2,81,81,70,88,122,120,2,
            2,2,73,116,81,2,2,2,70,88,
            2,2,2,2,2,2,2,2,2,2,
            2,2,2,2,2,2,2,2,2,2,
            2,106,76,106,106,2,2,78,78,2,
            2,2,2,2,2,2,2,2,2,2,
            2,2,2,78,78,2,73,89,5,73,
            71,73,76,85,70,2,89,89,105,105,
            105,105,105,105,15,73,80,73,73,26,
            4,15,32,19,18,17,16,20,5,30,
            29,28,85,71
        };
    };
    public final static char scopeLa[] = ScopeLa.scopeLa;
    public final int scopeLa(int index) { return scopeLa[index]; }

    public interface ScopeStateSet {
        public final static char scopeStateSet[] = {
            8,8,4,37,6,37,37,8,8,135,
            4,37,4,8,37,35,35,35,37,37,
            6,6,36,35,35,35,35,35,35,35,
            35,35,35,35,35,35,35,35,35,3,
            3,37,37,37,37,4,4,37,37,135,
            135,135,4,4,4,4,4,4,4,4,
            4,4,4,37,37,37,33,40,11,123,
            135,4,6,4,37,37,40,40,37,37,
            37,37,37,37,8,1,51,123,123,42,
            42,44,44,48,48,48,48,51,51,54,
            54,54,33,123
        };
    };
    public final static char scopeStateSet[] = ScopeStateSet.scopeStateSet;
    public final int scopeStateSet(int index) { return scopeStateSet[index]; }

    public interface ScopeRhs {
        public final static char scopeRhs[] = {0,
            284,360,269,103,269,102,269,124,123,0,
            92,0,284,3,87,269,121,0,86,0,
            359,330,284,269,117,0,84,0,284,329,
            358,3,87,269,101,0,78,0,284,357,
            269,115,0,80,0,318,0,291,0,0,
            269,76,297,304,91,245,0,16,0,297,
            304,91,245,0,15,232,16,0,269,76,
            297,246,0,269,353,76,297,304,90,0,
            297,304,90,0,15,0,232,16,0,287,
            85,295,0,18,232,0,295,0,22,264,
            18,232,0,351,1,348,0,12,0,350,
            1,347,0,344,74,35,0,14,0,277,
            71,277,1,35,0,277,1,35,0,19,
            263,12,0,302,74,36,0,277,1,36,
            0,265,0,33,239,0,277,1,273,58,
            0,277,1,273,57,0,277,1,273,59,
            0,274,0,18,271,0,342,69,0,111,
            271,0,111,232,0,269,65,0,271,0,
            102,271,0,308,105,269,65,0,102,270,
            271,0,103,271,0,102,270,103,271,0,
            308,106,308,105,269,65,0,103,270,271,
            0,102,270,103,270,271,0,104,0,102,
            270,104,0,103,270,104,0,102,270,103,
            270,104,0,306,1,232,94,0,306,1,
            232,93,0,340,274,69,0,276,1,273,
            234,0,276,1,273,30,0,276,1,273,
            29,0,276,1,273,28,0,276,1,273,
            19,0,276,1,273,18,0,276,1,273,
            17,0,276,1,273,16,0,276,1,273,
            26,0,276,1,273,4,0,276,1,273,
            32,0,276,1,273,20,0,276,1,273,
            5,0,276,1,273,60,0,276,1,273,
            62,0,276,1,273,61,0,276,1,273,
            232,0,276,1,273,54,0,276,1,273,
            15,0,339,1,34,0,277,1,231,0,
            277,79,3,0,7,232,0,269,73,274,
            85,274,1,39,0,274,85,274,1,39,
            0,18,232,12,0,274,1,39,0,22,
            262,18,232,12,0,269,73,274,1,39,
            0,274,71,274,0,19,262,18,232,0,
            285,1,50,0,285,1,49,0,285,1,
            48,0,285,1,47,0,285,1,46,0,
            285,1,45,0,285,1,43,0,285,1,
            44,0,285,1,42,0,285,1,41,0,
            285,1,40,0,335,74,34,0,302,74,
            231,0,269,1,0,276,1,232,75,230,
            0,276,1,64,0,258,0,4,246,0,
            3,246,0,262,0,2,244,0,1,244,
            0,263,0,9,241,0,8,241,0,6,
            241,0,5,241,0,10,239,0,7,239,
            0,267,0,107,237,0,106,237,0,105,
            237,0
        };
    };
    public final static char scopeRhs[] = ScopeRhs.scopeRhs;
    public final int scopeRhs(int index) { return scopeRhs[index]; }

    public interface ScopeState {
        public final static char scopeState[] = {0,
            1605,0,5073,4974,0,465,0,421,377,0,
            2647,2589,2707,2649,2591,2533,2475,2417,2359,2301,
            2243,2185,2127,2531,1605,5016,2473,2415,2241,5232,
            2058,5231,5233,0,4974,5073,4946,4918,4890,4860,
            4830,4798,478,4763,4728,2810,1976,4691,4654,4617,
            4578,4539,4500,4415,4371,4327,4283,4239,3026,2981,
            4195,4151,4107,1882,1833,4063,2765,4019,3975,3931,
            3887,3843,1753,1673,1605,2936,1556,3799,2060,3755,
            3711,3667,2012,3623,1507,1458,3579,1409,1360,1311,
            1262,1213,1164,1115,1066,1017,968,919,870,821,
            772,723,1931,3535,2891,3491,421,3447,3403,4459,
            674,598,522,3359,3315,3271,3227,3183,2846,3139,
            377,3095,2707,2649,2591,2533,2475,2417,2359,2301,
            2243,2185,2127,0,5222,5217,5212,5207,5202,5197,
            5177,5143,5138,5133,5008,5123,5118,5112,5107,1668,
            5102,5003,4988,4983,0
        };
    };
    public final static char scopeState[] = ScopeState.scopeState;
    public final int scopeState(int index) { return scopeState[index]; }

    public interface InSymb {
        public final static char inSymb[] = {0,
            0,331,126,286,72,311,314,109,286,72,
            312,315,110,235,300,299,97,98,230,72,
            72,72,291,3,4,3,72,75,286,286,
            1,77,75,1,77,4,316,35,36,230,
            3,231,34,277,277,316,277,2,71,2,
            1,1,96,79,1,1,284,283,282,71,
            2,284,77,4,77,277,277,69,54,15,
            1,65,234,58,57,59,63,30,29,28,
            19,18,17,16,26,32,20,5,60,62,
            61,231,34,235,4,31,36,35,3,25,
            24,23,22,21,233,232,230,64,245,246,
            258,262,265,263,270,267,277,277,339,3,
            295,318,112,111,115,101,117,121,123,72,
            77,277,2,277,71,274,342,3,269,269,
            273,273,273,273,273,273,273,273,273,273,
            273,273,273,273,273,273,273,273,273,74,
            74,273,74,74,273,75,1,91,90,94,
            93,297,26,4,15,32,80,20,5,19,
            18,17,16,107,30,29,28,96,5,79,
            71,283,355,230,269,269,269,269,124,282,
            277,284,77,284,277,340,341,71,89,71,
            5,105,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,302,269,86,15,303,335,1,302,344,
            309,345,1,232,276,275,304,54,15,4,
            234,232,304,234,349,348,347,39,343,50,
            49,48,47,46,45,43,44,42,41,40,
            232,232,76,258,258,263,263,263,267,265,
            265,265,277,356,1,357,87,284,87,269,
            72,284,277,89,71,3,308,276,277,277,
            277,334,230,276,276,276,276,276,276,276,
            276,276,276,276,276,276,276,92,86,71,
            71,276,5,71,276,1,71,297,273,273,
            273,273,297,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            269,5,101,77,275,284,3,330,118,3,
            102,284,106,276,76,1,1,76,351,295,
            350,295,3,274,285,274,285,285,285,285,
            285,285,285,285,285,285,306,95,307,306,
            269,358,113,359,119,269,284,269,308,269,
            276,276,353,3,85,73,85,73,71,73,
            79,71,100,329,284,103,269,287,274,269,
            274,284,269,73,73,73,360,269,284
        };
    };
    public final static char inSymb[] = InSymb.inSymb;
    public final int inSymb(int index) { return inSymb[index]; }

    public interface Name {
        public final static String name[] = {
            "",
            "+",
            "-",
            "*",
            "/",
            ">",
            "<",
            "=",
            ">=",
            "<=",
            "<>",
            "(",
            ")",
            "{",
            "}",
            "[",
            "]",
            "->",
            "|",
            ",",
            ":",
            "::",
            ";",
            ".",
            "..",
            "@pre",
            "^",
            "^^",
            "?",
            "+=",
            ":=",
            "@",
            "!",
            "!=",
            "::=",
            "\\u00AB",
            "$empty",
            "NUMERIC_OPERATION",
            "STRING_LITERAL",
            "INTEGER_LITERAL",
            "REAL_LITERAL",
            "INTEGER_RANGE_START",
            "class",
            "composes",
            "constructor",
            "datatype",
            "default",
            "derived",
            "do",
            "elif",
            "enum",
            "except",
            "exception",
            "from",
            "literal",
            "ordered",
            "primitive",
            "raise",
            "readonly",
            "references",
            "tag",
            "try",
            "typedef",
            "unlimited",
            "invalid",
            "IMPORT",
            "EXTENSION",
            "AROUND",
            "ENDAROUND",
            "DEFINE",
            "ENDDEFINE",
            "ERROR",
            "EXPAND",
            "FOR",
            "SEPARATOR",
            "AS",
            "ITERATOR",
            "FOREACH",
            "ENDFOREACH",
            "FILE",
            "ENDFILE",
            "IF",
            "ELSEIF",
            "ELSE",
            "ENDIF",
            "LET",
            "ENDLET",
            "PROTECT",
            "CSTART",
            "CEND",
            "ID",
            "DISABLE",
            "ENDPROTECT",
            "self",
            "inv",
            "pre",
            "post",
            "context",
            "package",
            "endpackage",
            "def",
            "if",
            "then",
            "else",
            "endif",
            "and",
            "or",
            "xor",
            "not",
            "implies",
            "let",
            "in",
            "true",
            "false",
            "body",
            "derive",
            "init",
            "null",
            "attr",
            "oper",
            "Set",
            "Bag",
            "Sequence",
            "Collection",
            "OrderedSet",
            "iterate",
            "forAll",
            "exists",
            "isUnique",
            "any",
            "one",
            "collect",
            "select",
            "reject",
            "collectNested",
            "sortedBy",
            "closure",
            "oclIsKindOf",
            "oclIsTypeOf",
            "oclAsType",
            "oclIsNew",
            "oclIsUndefined",
            "oclIsInvalid",
            "oclIsInState",
            "allInstances",
            "String",
            "Integer",
            "UnlimitedNatural",
            "Real",
            "Boolean",
            "Tuple",
            "OclAny",
            "OclVoid",
            "Invalid",
            "OclMessage",
            "OclInvalid",
            "end",
            "while",
            "out",
            "object",
            "transformation",
            "import",
            "library",
            "metamodel",
            "mapping",
            "query",
            "helper",
            "inout",
            "when",
            "var",
            "configuration",
            "intermediate",
            "property",
            "opposites",
            "population",
            "map",
            "new",
            "xmap",
            "late",
            "log",
            "assert",
            "with",
            "resolve",
            "resolveone",
            "resolveIn",
            "resolveoneIn",
            "invresolve",
            "invresolveone",
            "invresolveIn",
            "invresolveoneIn",
            "modeltype",
            "uses",
            "where",
            "refines",
            "access",
            "extends",
            "blackbox",
            "abstract",
            "static",
            "result",
            "main",
            "this",
            "switch",
            "case",
            "xselect",
            "xcollect",
            "selectOne",
            "collectOne",
            "collectselect",
            "collectselectOne",
            "return",
            "rename",
            "disjuncts",
            "merges",
            "inherits",
            "forEach",
            "forOne",
            "compute",
            "Dict",
            "List",
            "break",
            "continue",
            "EOF_TOKEN",
            "IDENTIFIER",
            "STEREOTYPE_QUALIFIER_OPEN",
            "STEREOTYPE_QUALIFIER_CLOSE",
            "MULTIPLICITY_RANGE",
            "TILDE_SIGN",
            "TEXT",
            "ERROR_TOKEN",
            "keywordAsIdentifier1",
            "keywordAsIdentifier",
            "oclExpressionCS",
            "impliesExpCS",
            "andOrXorExpCS",
            "andOrXorWithLet",
            "equalityExpCS",
            "equalityWithLet",
            "relationalExpCS",
            "relationalWithLet",
            "ifExpCSPrec",
            "additiveWithLet",
            "additiveExpCS",
            "multiplicativeExpCS",
            "multiplicativeWithLet",
            "unaryExpCS",
            "unaryWithLet",
            "dotArrowExpCS",
            "oclExpCS",
            "callExpCS",
            "messageExpCS",
            "pathNameCS",
            "simpleNameCS",
            "keywordOperationCallExpCS",
            "collectionTypeIdentifierCS",
            "collectionLiteralPartsCS",
            "collectionLiteralPartCS",
            "stringLiteralExpCS",
            "variableListCS2",
            "featureCallExpCS",
            "loopExpCS",
            "iterContents",
            "variableCS",
            "typeCS",
            "variableCS2",
            "variableListCS",
            "argumentsCS",
            "letExpSubCS",
            "oclMessageArgumentsCS",
            "oclMessageArgCS",
            "ifExpBodyCS",
            "qvtErrorToken",
            "letExpSubCS3",
            "iteratorExpCSToken",
            "literalSimpleCS",
            "dictLiteralPartCS",
            "dictLiteralPartListCS",
            "imperativeIteratorExpCSToken12",
            "imperativeIteratorExpCSToken3",
            "imperativeIteratorExpCSToken",
            "imperativeIterContents12",
            "imperativeIterContents3",
            "defineOrAroundSeq",
            "define",
            "around",
            "anImport",
            "anExtensionImport",
            "pointcut",
            "sequence",
            "parametersList",
            "parameter",
            "text",
            "statement",
            "definitionName"
        };
    };
    public final static String name[] = Name.name;
    public final String name(int index) { return name[index]; }

    public final static int
           ERROR_SYMBOL      = 70,
           SCOPE_UBOUND      = 103,
           SCOPE_SIZE        = 104,
           MAX_NAME_LENGTH   = 30;

    public final int getErrorSymbol() { return ERROR_SYMBOL; }
    public final int getScopeUbound() { return SCOPE_UBOUND; }
    public final int getScopeSize() { return SCOPE_SIZE; }
    public final int getMaxNameLength() { return MAX_NAME_LENGTH; }

    public final static int
           NUM_STATES        = 429,
           NT_OFFSET         = 228,
           LA_STATE_OFFSET   = 5735,
           MAX_LA            = 2,
           NUM_RULES         = 376,
           NUM_NONTERMINALS  = 133,
           NUM_SYMBOLS       = 361,
           SEGMENT_SIZE      = 8192,
           START_STATE       = 4996,
           IDENTIFIER_SYMBOL = 3,
           EOFT_SYMBOL       = 108,
           EOLT_SYMBOL       = 108,
           ACCEPT_ACTION     = 5358,
           ERROR_ACTION      = 5359;

    public final static boolean BACKTRACK = false;

    public final int getNumStates() { return NUM_STATES; }
    public final int getNtOffset() { return NT_OFFSET; }
    public final int getLaStateOffset() { return LA_STATE_OFFSET; }
    public final int getMaxLa() { return MAX_LA; }
    public final int getNumRules() { return NUM_RULES; }
    public final int getNumNonterminals() { return NUM_NONTERMINALS; }
    public final int getNumSymbols() { return NUM_SYMBOLS; }
    public final int getSegmentSize() { return SEGMENT_SIZE; }
    public final int getStartState() { return START_STATE; }
    public final int getStartSymbol() { return lhs[0]; }
    public final int getIdentifierSymbol() { return IDENTIFIER_SYMBOL; }
    public final int getEoftSymbol() { return EOFT_SYMBOL; }
    public final int getEoltSymbol() { return EOLT_SYMBOL; }
    public final int getAcceptAction() { return ACCEPT_ACTION; }
    public final int getErrorAction() { return ERROR_ACTION; }
    public final boolean isValidForParser() { return isValidForParser; }
    public final boolean getBacktrack() { return BACKTRACK; }

    public final int originalState(int state) {
        return -baseCheck[state];
    }
    public final int asi(int state) {
        return asb[originalState(state)];
    }
    public final int nasi(int state) {
        return nasb[originalState(state)];
    }
    public final int inSymbol(int state) {
        return inSymb[originalState(state)];
    }

    public final int ntAction(int state, int sym) {
        return baseAction[state + sym];
    }

    public final int tAction(int state, int sym) {
        int i = baseAction[state],
            k = i + sym;
        return termAction[termCheck[k] == sym ? k : i];
    }
    public final int lookAhead(int la_state, int sym) {
        int k = la_state + sym;
        return termAction[termCheck[k] == sym ? k : la_state];
    }
}
